'Compilable Example:
#Compile Exe "gbcoderx.exe"
#Dim All
#Debug Error On
#Debug Display On
%Unicode = 1
#Include "Win32API.inc"
#Include "Scintilla.inc"
#Include "files\gbOnlineUpdate.inc"

#Resource Icon logo "images\gbcoderx.ico"
#Resource Icon xsortup "images\psortup.ico"
#Resource Icon xsortdown "images\psortdown.ico"
#Resource Icon xsettings "images\settings.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xnew "images\new.ico"
#Resource Icon xopen "images\open.ico"
#Resource Icon xshowp "images\filterp.ico"
#Resource Icon xshownp "images\filternp.ico"
#Resource Icon xshowlist "images\list.ico"
#Resource Icon xreload "images\reload.ico"
#Resource Icon xcopyleft "images\left.ico"
#Resource Icon xcopyright "images\right.ico"
#Resource Icon xfont "images\font.ico"
#Resource Icon xide "images\pbwin.ico"
#Resource Icon xsaveas "images\saveas.ico"
#Resource Icon xall "images\build.ico"
#Resource Icon xtree "images\treecall.ico"
#Resource Icon xtreex "images\treecalled.ico"
#Resource Icon xup "images\sortascending.ico"
#Resource Icon xdown "images\sortdescending.ico"
#Resource Icon xsearch "images\search.ico"
#Resource Icon xmerge "images\merge.ico"
#Resource Icon xtools "images\tools.ico"
#Resource Icon xapitree "images\apitree.ico"
#Resource Icon xformat "images\format.ico"
#Resource Icon xjustify "images\justify.ico"

#Resource RcData xcursor "images\dragdrop.cur"

Enum Equates Singular
   IDC_ScintillaA = 500
   IDC_ScintillaB
   IDC_LabelA
   IDC_LabelB
   IDC_Toolbar
   IDC_TreeView
   IDC_ListView

   IDT_Open
   IDT_Reload
   IDT_New
   IDT_OpenInIDE
   IDT_SortA
   IDT_SortD
   IDT_Settings
   IDT_ShowProcedureNames
   IDT_Format
   IDT_Justify
   IDT_APITree
   IDT_Merge
   IDT_CallTree
   IDT_CalledTree
   IDT_CopyLeft
   IDT_CopyRight
   IDT_Copy
   IDT_ShowP
   IDT_ShowNP
   IDT_Font
   IDT_SaveAs
   IDT_Build
   IDT_Tools
   IDT_Search
   IDT_Help

   IDM_Cut
   IDM_Copy
   IDM_CopyAll
   IDM_Paste
   IDM_Delete
   IDM_Clear
   IDM_Test
   IDM_LoadExample
   IDM_Sep
   IDM_SkipPBMain
   IDM_SkipDlgProc
   IDM_UpperCase
   IDM_LowerCase
   IDM_MixedCase
   IDM_PlusTree
   IDM_UseIncludes
   IDM_UseSpeech
   IDM_MinimalToolbar
   IDM_UseNestedIncludes
   IDM_UseIncludeSeparators
   IDM_OnlineUpdate
   IDM_SelectIDE
   IDM_OpenCFNInIDE
   IDM_OpenAInIDE
   IDM_OpenBInIDE
   IDM_SyntaxHighlighting
   IDM_ProcedureHighlighting
   IDM_APIHighlighting
   IDM_ReverseCallOrder
   IDM_ForwardCallOrder
   IDM_AscendingOrder
   IDM_TweenerAsNP
   IDM_ExportTree

   IDM_CollapseAll
   IDM_ExpandAll
   IDM_FindCalls

   IDM_CheckAll
   IDM_UnCheckAll
   IDM_DeleteChecked
   IDM_BuildOutputChecked
   IDM_BuildOutputAll
   IDM_BuildOutputCheckedNP
   IDM_BuildOutputAllNP
   IDM_DeleteSelected

   IDM_SkipFile

   IDM_mShowProcedureNames
   IDM_mCopyLeft
   IDM_mCopyRight
   IDM_mFormat
   IDM_mJustify
   IDM_mAPITree
   IDM_mShowP
   IDM_mShowNP
   IDM_mSortA
   IDM_mSortD
   IDM_mBuild
   IDM_mMerge
   IDM_mCallTree
   IDM_mCallingTree

   IDM_Tool_PBReference 'Brown
   IDM_Tool_PBCodec     'Borje
   IDM_Tool_gbSearch
   IDM_Tool_gbSearchLite
   IDM_Tool_gbMagnify
   IDM_Tool_gbRuler

   IDF_FindThis
   IDF_FindText
   IDF_ReplaceThis
   IDF_ReplaceText
   IDF_Find
   IDF_Replace
   IDF_ReplaceAll
   IDF_Close
   IDF_MatchCase
   IDF_MatchWord
   IDF_Up
   IDF_Down

   'Display
   cListView = 1
   cTreeView = 2
   cScintilla = 3

   'Lexer
   Style_Numbers   = 1
   Style_Strings   = 2
   Style_Keywords  = 3
   Style_Comments  = 4
   Style_Operators = 6
   Style_Light     = 10
   Style_Dark      = 11
   Style_URL       = 12
   Style_HotSpot   = 13

   Ascending
   Descending
End Enum

Type APIType
   name As StringZ * 50
   parent As StringZ * 50
End Type

Type ProcedureType
   name As StringZ * 50
   parent As WStringZ * %Max_Path
   cat As StringZ * 10     'Sub, Function, Class, Callback
   used As Long
   ipos As Long
End Type

$Ver = "3.0"
$FileIn = "tempfiles\filein.bas"
$FileOut = "tempfiles\fileout.bas"
$FileOutTreeView = "tempfiles\fileout_treeview.txt"
$FileOutListView = "tempfiles\fileout_listview.txt"
$KeyWordFile = "files\powerbasic_keywords.txt"
$SkipListFile = "files\skiplist.txt"
$APIListFile = "files\api_jose.txt"
$IDESourceCodeFileA  = "tempfiles\gbcoderx_ide.bas"       'sent to PowerBASIC IDE
$IDESourceCodeFileB  = "tempfiles\gbcoderx_ide.bas"       'sent to PowerBASIC IDE
$TreeFile = "tempfiles\gbcoderx_tree.txt"

Macro IndentD = D(i) = Space$(iLevel*IndentSize) + D(i)
Macro IndentD1 = D(i) = Space$((iLevel+1)*IndentSize) + D(i)
Macro IG   = D(i) = Space$(iLevel*IndentSize) + D(i) : GoTo Finish
Macro IIG  = D(i) = Space$(iLevel*IndentSize) + D(i) : Incr iLevel : GoTo Finish
Macro DIIG = Decr iLevel : D(i) = Space$(iLevel*IndentSize) + D(i) : Incr iLevel : GoTo Finish
Macro DIG  = Decr iLevel : D(i) = Space$(iLevel*IndentSize) + D(i) : GoTo Finish
Macro ZG   = iLevel = 0 : GoTo Finish
Macro FG   = fFlag = 1 : GoTo Finish
Macro IIFG  = D(i) = Space$(iLevel*IndentSize) + D(i) : fFlag = 1 : Incr iLevel : GoTo Finish
Macro IFG  = D(i) = Space$(iLevel*IndentSize) + D(i) : fFlag = 1 : GoTo Finish
Macro DFG  = Decr iLevel : fFlag = 1 : GoTo Finish
Macro ZFG  = iLevel = 0 : fFlag = 1 : GoTo Finish
Macro OFG  = iLevel = 1 : fFlag = 1 : GoTo Finish

Global hDlg,hSettings,hTools,hContextTV,hContextLV,hHelp,hToolbar,hFontCode,hFontC,hPBWin,hTree,hActions As Dword
Global hSciA,hSciB,hContextA,hContextB,ghHook,hLib,hFontB,hFontF,hTreeViwe,hFont,hListView,hFind As Dword
Global hCursor, hHeader, hImageListLV, hImageListTB As Dword, DragInWork, SortDirection, StartItem, EndItem As Long
Global ProcedureWords, KeyWords(), SkipList, Includes(), IncludesCode, APISearchList As String
Global SearchTerm, ReplaceTerm, FileName, FontName, LabelList, LabelTree, LabelSci As WStringZ * %Max_Path
Global CodeCase, FontSize, FontAttr, ProcedureHighlighting, APIHighlighting, SyntaxHighlighting, ProcedureOrder As Long
Global SkipPBMain, SkipDlgProc, OrigScintillaProc,Layout, PBMainIndex, DlgProcIndex, TweenerAsNP As Long
Global PathIDE, PathCompile, PathIncludePB, PathIncludeJR As WStringZ * %Max_Path

Global ColorComments, ColorKeywords, ColorNumbers, ColorOperators, ColorStrings, UseSpeech, MinimalToolbar As Long
Global SyntaxInWork, ShowBars, ShowHL, ShowF2S, ShowF2G, WideF2S, WideF2G, ShowURLs, ShowFold, ShowAutoC As Long
Global OldScintillaProc, GBLink, ShowTips, IndentNumber, Tab2SpacesNumber As Long
Global UseIncludeSeparators, UseIncludes, UseNestedIncludes, PlusTree, ControlType, IndentSize, ManageBlankLines, FixedB, MaxB As Long
Global AutoIndent, ShowBraces, CodeCase, ShowLineNumbers, ShowGuides, ControlType As Long
Global FindStructure As Sci_TextToFind, APIUsedList, tempAPIArray() As String

Global NPCode, Procedures(), ProcedureInside() As String, ProcedureData() As ProcedureType
Global ReverseCallResults() As String, ReverseCallResultsN() As Long

Global xFindText, xReplaceText, SelectedText As String, hSciF As Dword
Global MatchWord, MatchCase, Direction, FindFlags, SelLength, Anchor, CurPos, sCID As Long
Global FindStructure As Sci_TextToFind

Function PBMain() As Long
   Dialog New Pixels, 0, "gbCodeRX  v" + $ver,300,300,600,300, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateListView
   CreateImageList
   CreateContextMenus
   CreateTreeView
   Control Add Label, hDlg, %IDC_LabelA, "Input",10,55,100,25, %SS_Notify
   Control Add Label, hDlg, %IDC_LabelB, "Output",10,55,400,25, %SS_Notify
   CreateScintillaControls
   Dialog Show Modal hDlg Call DlgProc
   If RestartUpdate Then RestartUpdatedEXE
End Function

CallBack Function DlgProc() As Long
   Local x,y,w,h As Long, tmp$,temp$,PTT As TooltipText Ptr, nmtb As TBNotify Ptr, rc As Rect
   Local pNSC As SCNotification Ptr, hNode As Dword, LVData As NM_ListView
   Local NMLV As NMListView Ptr, LVHT As LVHitTestInfo, LVI As LV_ITEMW

   Select Case Cb.Msg
      Case %WM_InitDialog
         Settings_INI "get"
         CreateToolbar
         SetOutputLabelText
         LoadSkipList
         If IsFolder (Exe.Path$ + "tempfiles") = %False Then MkDir Exe.Path$ + "tempfiles"
         hCursor = LoadOneCursor("xcursor")
         Font New FontName, FontSize, FontAttr To hFontCode
         Font New "Tahoma",10,0 To hFont
         Font New "Tahoma",12,1 To hFontB
         Font New "Tahoma",8,0 To hFontF
         Font New "Tahoma", FontSize, FontAttr To hFontC
         Control Set Font hDlg, %IDC_Toolbar, hFont
         Control Set Font hDlg, %IDC_LabelA, hFontB
         Control Set Font hDlg, %IDC_LabelB, hFontB
         Control Set Font hDlg, %IDC_TreeView, hFontC 'Code
         Control Set Font hDlg, %IDC_ListView, hFontC 'Code
         SetSciFonts
         LoadAPIList

         hUpdateParent = hDlg
         InitializeKeywords
         If IsFolder (Exe.Path$ + "tempfiles") = %False Then MkDir Exe.Path$ + "tempfiles"
         BuildAcceleratorTable
         Dialog Set Text hDlg, "gbCodeRX  v" + $ver + Space$(10) + FileName
         If IsFile($FileIn) Or IsFile($FileOut) Then LoadFiles Else LoadTestProcedures
         SetMenusAndToolbar

         BuildOutputs
         InitializeSci
         SetSyntaxColors

         PostMessage hSciA, %SCI_SetSel, 0, 0  'unselect initially
         PostMessage hSciB, %SCI_SetSel, 0, 0  'unselect initially

      Case %WM_Destroy
         Settings_INI "save"
         SaveFiles
         DestroyWindow hSciA
         DestroyWindow hSciB
         If hLib Then FreeLibrary hLib

      Case %WM_ContextMenu
         Select Case Cb.WParam
            Case GetDlgItem(hDlg, %IDC_ScintillaA)
               x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
               TrackPopupMenu hContextA, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
               Function = 0 : Exit Function
            Case GetDlgItem(hDlg, %IDC_ScintillaB)
               x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
               TrackPopupMenu hContextB, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
               Function = 0 : Exit Function
            Case GetDlgItem(hDlg, %IDC_ListView)
               x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
               TrackPopupMenu hContextLV, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
               Function = 0 : Exit Function
            Case GetDlgItem(hDlg, %IDC_TreeView)
               Local TVht As TV_HitTestInfo
               x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)
               'select the item under the mouse when a right-click is made
               TVht.pt.x = x
               TVht.pt.y = y
               MapWindowPoints(%HWND_Desktop, Cb.WParam, ByVal VarPtr(Tvht.pt), 1)
               SendMessage(Cb.WParam, %TVM_HITTEST, 0, ByVal VarPtr(TVht))
               Treeview Select hDlg, %IDC_TreeView, TVht.hItem
               TrackPopupMenu hContextTV, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0
         End Select

      Case %WM_SetCursor
         If Cb.WParam <> hListView Then Exit Function
         GetCursorPos LVHT.pt
         ScreenToClient hListView, LVHT.pt
         Control Send hDlg, %IDC_ListView, %LVM_SubItemHitTest, 0, VarPtr(LVHT)
         Select Case Hi(Word, Cb.LParam)  'monitors lbuttondown, mousemose, lbuttonup
            Case %WM_LButtonUp
               If DragInWork Then
                  If LVHT.iItem = -1 Then DragInWork = 0 : Exit If
                  EndItem = LVHT.iItem
                  RearrangeListViewItems   'after drop
                  DragInWork = 0
               End If
             Case %WM_MouseMove
                If DragInWork Then
                    MousePtr hCursor : Function = 1
                    If LVHT.iItem > -1 Then
                       lvi.state     = %LVIS_FOCUSED 'Or %LVIS_Selected
                       lvi.stateMask = %LVIS_FOCUSED 'Or %LVIS_Selected
                       SendMessage hListView, %LVM_SetItemState, LVHT.iItem, VarPtr(LVI)
                    End If
                End If
          End Select

      Case %WM_Notify
         If Cb.NmCode = %TTN_GetDispInfo Then
            PTT = Cb.LParam
            @PTT.@lpszText = SetToolTips(Cb.NmId)
         End If

         Select Case Cb.NmId
            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_OpenInIDE
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hPBWin, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Help
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hHelp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Build
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hActions, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Tools
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hTools, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select

            Case %IDC_TreeView
               Select Case Cb.NmCode
                  Case %NM_DblClk
                     GotoProcedure_TreeView
               End Select

            Case %IDC_ListView
               Select Case Cb.NmCode
                  Case %NM_DblClk
                     GotoProcedure_ListView

                  Case %LVN_BeginDrag
                     NMLV = Cb.LParam
                     DragInWork = 1
                     StartItem = @NMLV.iItem
                     SetFocus(hListView)
                     SendMessage(hListView, %WM_KeyDown, %VK_TAB, 0)
                     SendMessage(hListView, %WM_Char,    %VK_TAB, 0)
                     SendMessage(hListView, %WM_KeyUp,   %VK_TAB, 0)

                  Case %LVN_ColumnClick
                     Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                     SortDirection = SortDirection Xor 1
                     If SortDirection Then
                        ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Ascend
                     Else
                        ListView Sort hDlg, %IDC_ListView, LVData.iSubItem+1, Descend
                     End If
                     SetHeaderIConsOnRight LVData.iSubItem
               End Select
         End Select


      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Test
               LabelSci = "Output  (" + "API List)"
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cScintilla : ResizeWindow
               BuildOutputs
               temp$ = APIUsedList
               Replace $Spc With $CrLf In temp$
               SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)

            Case %IDC_ScintillaA
               Select Case Cb.CtlMsg
                  Case %SCEN_SetFocus : hSciF = hSciA : sCID = %IDC_ScintillaA
               End Select

            Case %IDC_ScintillaB
               Select Case Cb.CtlMsg
                  Case %SCEN_SetFocus : hSciF = hSciB : sCID = %IDC_ScintillaB
               End Select

            Case %IDT_Open   : SelectAndOpenFile

            Case %IDT_Reload : LoadFileNameContent

            Case %IDT_New
               temp$ = ""
               SendMessage hSciA, %SCI_SetText, 0, StrPtr(temp$)
               SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
               Treeview Reset hDlg, %IDC_TreeView
               ListView Reset hDlg, %IDC_ListView

            Case %IDT_Justify, %IDM_mJustify
               MousePtr 11
               If ControlType = %cScintilla Then
                  LabelSci = "Output  (" + "Justified Input)"
                  Control Set Text hDlg, %IDC_LabelB, LabelSci
                  ControlType = %cScintilla
                  JustifyCode
                  ResizeWindow
               Else
                  If UseSpeech Then
                     ReadText "Cannot left justify"
                  Else
                     sndPlaySound("MailBeep", %SND_Async)    'play sound once (in the background)
                  End If
               End If
               MousePtr 1


            Case %IDT_Format, %IDM_mFormat
               MousePtr 11
               LabelSci = "Output  (" + "Formatted Input)"
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cScintilla
               FormatCode
               ResizeWindow
               MousePtr 1

            Case %IDT_ShowProcedureNames, %IDM_mShowProcedureNames
               MousePtr 11
               LabelList = "Output  (" + "Procedure Titles)"
               Control Set Text hDlg, %IDC_LabelB,LabelList
               ControlType = %cListView
               BuildOutputs
               ListView Reset hDlg, %IDC_ListView
               For x = 0 To UBound(ProcedureData)
                  If Len(ProcedureData(x).name) Then
                     ListView Insert Item hDlg, %IDC_ListView, x+1, 0, ProcedureData(x).name
                     ListView Set Text hDlg, %IDC_ListView, x+1, 2, ProcedureData(x).cat
                     ListView Set Text hDlg, %IDC_ListView, x+1, 3, Format$(x,"000")
                  End If
               Next x
               If UseIncludes Then
                  y = UBound(ProcedureData)+1
                  For x = 0 To UBound(Includes)
                     If Len(Includes(x)) Then
                        ListView Insert Item hDlg, %IDC_ListView, y+x+1, 0, Includes(x)
                        ListView Set Text hDlg, %IDC_ListView, y+x+1, 2, IIf$(IsFile(Includes(x)),"Include","Include**")
                        ListView Set Text hDlg, %IDC_ListView, y+x+1, 3, "n/a"
                     End If
                  Next x
               End If
               ResizeWindow
               MousePtr 1

            Case %IDT_APITree, %IDM_mAPITree
               MousePtr 11
               LabelSci = "Output  (" + "API Called Tree)"
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cTreeView
               BuildOutputs
               BuildAPITree
               ResizeWindow
               MousePtr 1

            Case %IDT_ShowP, %IDM_mShowP
               MousePtr 11
               LabelSci = "Output  (" + "Procedure Listings, Unsorted)"
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cScintilla
               BuildOutputs
               temp$ = Trim$(Join$(Procedures(), ""), $CrLf)
               SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
               ResizeWindow
               MousePtr 1

            Case %IDT_CallTree, %IDM_mCallTree
               MousePtr 11
               LabelTree = "Output  (" + "Call Tree)"
               Control Set Text hDlg, %IDC_LabelB, LabelTree
               ControlType = %cTreeView
               BuildOutputs
               BuildCallTree
               ResizeWindow
               MousePtr 1

            Case %IDT_CalledTree, %IDM_mCallingTree
               MousePtr 11
               LabelTree = "Output  (" + "Called By Tree)"
               Control Set Text hDlg, %IDC_LabelB, LabelTree
               ControlType = %cTreeView
               BuildOutputs
               BuildCallingTree
               ResizeWindow
               MousePtr 1

            Case %IDT_ShowNP, %IDM_mShowNP
               MousePtr 11
               LabelSci = "Output  (" + "nonProcedure Code)"
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cScintilla
               BuildOutputs
               SendMessage hSciB, %SCI_SetText, 0, StrPtr(NPCode)
               ResizeWindow
               MousePtr 1

            Case %IDT_SortA, %IDM_mSortA
               MousePtr 11
               LabelSci = "Output  (" + "Procedures, Sorted Ascending)"
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cScintilla
               BuildOutputs
               Array Sort ProcedureData(), Collate UCase, TagArray Procedures(), Ascend    'sort Title() but with Procedures() as a tag-along array
               temp$ = Trim$(Join$(Procedures(),""),$CrLf)
               SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
               ResizeWindow
               MousePtr 1

            Case %IDT_SortD, %IDM_mSortD
               MousePtr 11
               LabelSci = "Output  (" + "Procedures, Sorted Descending)"
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cScintilla
               BuildOutputs
               Array Sort ProcedureData(), Collate UCase, TagArray Procedures(), Descend    'sort Title() but with Procedures() as a tag-along array
               temp$ = Trim$(Join$(Procedures(), ""), $CrLf)
               SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
               ResizeWindow
               MousePtr 1

            Case %IDT_Build
               MousePtr 11
               Select Case ProcedureOrder
                  Case 1 : LabelSci = "Output  (" + "All Code, Ascending Sort)"
                  Case 2 : LabelSci = "Output  (" + "All Code, Forward Call Order)"
                  Case 3 : LabelSci = "Output  (" + "All Code, Reverse Call Order)"
               End Select
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cScintilla
               BuildOutputs
               Array Sort ProcedureData(), Collate UCase, TagArray Procedures(), Ascend
               Select Case ProcedureOrder
                  Case 1 'ascending order
                     temp$ = Trim$(NPCode + $CrLf + $CrLf + Join$(Procedures(), ""), Any $CrLf + $Spc)
                     SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
                  Case 2 : BuildInForwardCallOrder
                  Case 3 : BuildInReverseCallOrder
               End Select
               ResizeWindow
               MousePtr 1

            Case %IDT_Merge, %IDM_mMerge
               MousePtr 11
               LabelSci = "Output  (" + "Includes Appended to Input)"
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cScintilla
               BuildOutputs
               temp$ = GetSciText(hSciA) + $CrLf
               For x = 0 To UBound(Includes)
                  If Len(Includes(x)) = 0 Then Iterate For
                  If IsFile(Includes(x)) Then
                     Open Includes(x) For Binary As #1 : Get$ #1, Lof(1), tmp$ : Close #1
                     temp$ = temp$  + $CrLf + IIf$(UseIncludeSeparators,"'---" + Includes(x) + Repeat$(25,"-")+$CrLf,"") + tmp$
                  End If
               Next i
               SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
               ResizeWindow
               MousePtr 1

            Case %IDT_CopyRight, %IDM_mCopyRight
               MousePtr 11
               LabelSci = "Output  (" + "Duplicate of Input)"
               Control Set Text hDlg, %IDC_LabelB, LabelSci
               ControlType = %cScintilla
               temp$ = GetSciText(hSciA)
               SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
               ResizeWindow
               MousePtr 1

            Case %IDT_CopyLeft, %IDM_mCopyLeft
               MousePtr 11
               If ControlType = %cScintilla Then
                  temp$ = GetSciText(hSciB)
                  SendMessage hSciA, %SCI_SetText, 0, StrPtr(temp$)
               Else
                  If UseSpeech Then
                     ReadText "Cannot copy left"
                  Else
                     sndPlaySound("MailBeep", %SND_Async)    'play sound once (in the background)
                  End If
               End If

            Case %IDT_SaveAs
               If ControlType = %cScintilla Then
                  SaveAs
               Else
                  If UseSpeech Then
                     ReadText "Cannot save."
                  Else
                     sndPlaySound("MailBeep", %SND_Async)    'play sound once (in the background)
                  End If
               End If
               MousePtr 1

            Case %IDT_OpenInIDE, %IDM_OpenBInIDE
               If Controltype = %cScintilla Then
                  Open $IDESourceCodeFileB For Output As #1
                  Print #1, GetSciText(hSciB);
                  Close #1
                  x = Shell(PathIDE + " " + $IDESourceCodeFileB, 1)  'does not wait
               Else
                  If UseSpeech Then
                     ReadText "Cannot open in I D E"
                  Else
                     sndPlaySound("MailBeep", %SND_Async)    'play sound once (in the background)
                  End If
               End If

            Case %IDT_Font : SelectMainFont

            Case %IDT_Settings
               Select Case Layout
                  Case 0 : Layout = 1
                  Case 1 : Layout = 2
                  Case 2 : Layout = 0
               End Select
               SetMenusAndToolbar
               ResizeWindow

            Case %IDT_Search
               Control Get Loc hDlg, %IDC_ScintillaA To x,y
               Control Get Loc hDlg, %IDC_ScintillaB To w,h
               If (hSciF=0) And (sCID=0) Then
                  hSciF = hSciA
                  sCID = %IDC_ScintillaA
                  DisplayFindDialog
               ElseIf hSciF = hSciA Then
                  If x <> -5000 Then
                     DisplayFindDialog
                  ElseIf w <> -5000 Then
                     hSciF = hSciB
                     sCID = %IDC_ScintillaB
                     DisplayFindDialog
                  Else
                     If UseSpeech Then
                        ReadText "Display cannot be searched."
                     Else
                        sndPlaySound("MailBeep", %SND_Async)    'play sound once (in the background)
                     End If
                  End If
               ElseIf hSciF = hSciB Then
                  If w <> -5000 Then
                     DisplayFindDialog
                  ElseIf x <> -5000 Then
                     hSciF = hSciA
                     sCID = %IDC_ScintillaA
                     DisplayFindDialog
                  End If
               Else
                  If UseSpeech Then
                     ReadText "Display cannot be searched."
                  Else
                     sndPlaySound("MailBeep", %SND_Async)    'play sound once (in the background)
                  End If
               End If

            Case %IDT_Help
               temp$ = "http://www.garybeene.com/sw/gbcoderx.htm"
               x = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_OpenCFNInIDE
               x = Shell(PathIDE + " " + FileName, 1)  'does not wait

            Case %IDM_OpenAInIDE
               Open $IDESourceCodeFileA For Output As #1
               Print #1, GetSciText(hSciA);
               Close #1
               x = Shell(PathIDE + " " + $IDESourceCodeFileA, 1)  'does not wait

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_CopyAll
               Clipboard Reset
               Clipboard Set Text GetSciText(GetDlgCtrlID(GetFocus))
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0
            Case %IDM_Clear
               temp$ = ""
               SendMessage GetDlgCtrlID(GetFocus), %SCI_SetText, 0, StrPtr(temp$)
            Case %IDM_SkipPBMain  : SkipPBMain  = SkipPBMain Xor 1  : SetMenusAndToolbar
            Case %IDM_SkipDlgProc : SkipDlgProc = SkipDlgProc Xor 1 : SetMenusAndToolbar

            Case %IDM_PlusTree    : PlusTree = PlusTree Xor 1 : SetMenusAndToolbar

            Case %IDM_UseSpeech   : UseSpeech = UseSpeech Xor 1 : SetMenusAndToolbar

            Case %IDM_MinimalToolbar
               MinimalToolbar = MinimalToolbar Xor 1
               CreateToolbar
               SetMenusAndToolbar

            Case %IDM_UseIncludes : UseIncludes = UseIncludes Xor 1 : SetMenusAndToolbar
            Case %IDM_UseNestedIncludes : UseNestedIncludes = UseNestedIncludes Xor 1 : SetMenusAndToolbar
            Case %IDM_UseIncludeSeparators : UseIncludeSeparators = UseIncludeSeparators Xor 1 : SetMenusAndToolbar

            Case %IDM_AscendingOrder    : ProcedureOrder = 1 : SetMenusAndToolbar
            Case %IDM_ForwardCallorder  : ProcedureOrder = 2 : SetMenusAndToolbar
            Case %IDM_ReverseCallOrder  : ProcedureOrder = 3 : SetMenusAndToolbar

            Case %IDM_SyntaxHighlighting
               SyntaxHighlighting = SyntaxHighlighting Xor 1
               SetSyntaxColors
               SetMenusAndToolbar

            Case %IDM_ProcedureHighlighting
               ProcedureHighlighting = ProcedureHighlighting Xor 1
               SetSyntaxColors
               SetMenusAndToolbar

            Case %IDM_APIHighlighting
               APIHighlighting = APIHighlighting Xor 1
               SetSyntaxColors
               SetMenusAndToolbar

            Case %IDM_TweenerAsNP
               TweenerAsNP = TweenerAsNP Xor 1
               SetMenusAndToolbar

            Case %IDM_UpperCase : CodeCase = 1 : SetCodeStyle : SetMenusAndToolbar
            Case %IDM_LowerCase : CodeCase = 2 : SetCodeStyle : SetMenusAndToolbar
            Case %IDM_MixedCase : CodeCase = 3 : SetCodeStyle : SetMenusAndToolbar

            Case %IDM_SelectIDE        : SelectIDE
            Case %IDM_OnlineUpdate : CheckForEXEUpdates($ver)

            Case %IDM_CollapseAll
               ShowFirstLevel

            Case %IDM_ExportTree : ExportTree

            Case %IDM_ExpandAll
               Treeview Get Root hDlg, %IDC_TreeView To hNode
               TreeNodeExpand(hNode, %True)

            Case %IDM_FindCalls
'               ShowTreeView = 1 : ResizeWindow
'               BuildCallTree
               FindSelectedProcedureCalls

            Case %IDC_LabelA
               FileName = ""
               Dialog Set Text hDlg, "gbCodeRX  v" + $ver + Space$(10) + FileName
               LoadTestProcedures
               BuildOutputs

            Case %IDC_LabelB
               BuildOutputs
               Select Case ControlType
                  Case %cListView
                     ControlType = %cTreeview
                     Control Set Text hDlg, %IDC_LabelB, LabelTree
                  Case %cTreeView
                     ControlType = %cScintilla
                     Control Set Text hDlg, %IDC_LabelB, LabelSci
                  Case %cScintilla
                     ControlType = %cListView
                     Control Set Text hDlg, %IDC_LabelB, LabelList
               End Select
               ResizeWindow

            Case %IDM_CheckAll            : CheckAll %True
            Case %IDM_UnCheckAll          : CheckAll %False
            Case %IDM_DeleteChecked       : DeleteChecked
            Case %IDM_DeleteSelected
               ListView Get Select hDlg, %IDC_ListView To x
               If x Then ListView Delete Item hDlg, %IDC_ListView, x

            Case %IDM_BuildOutputCheckedNP
               BuildOutputs
               BuildOutputChecked(1)
               ControlType = %cScintilla
               ResizeWindow

            Case %IDM_BuildOutputAllNP
               BuildOutputs
               BuildOutputAll(1)
               ControlType = %cScintilla
               ResizeWindow

            Case %IDM_BuildOutputChecked 'without NP
               BuildOutputs
               BuildOutputChecked(0)
               ControlType = %cScintilla
               ResizeWindow

            Case %IDM_BuildOutputAll   'without NP
               BuildOutputs
               BuildOutputAll(0)
               ControlType = %cScintilla
               ResizeWindow

            Case %IDM_Tool_PBReference
               x  = Shell ("tools\pbreference.exe", 1)  'opens, does not wait for it to close

            Case %IDM_Tool_PBCodec
               temp$ = GetSciText(hSciA)
               Open Exe.Path$ + "tempfiles\gbcoderx_pbcodec.bas" For Output As #1 : Print #1, temp$ : Close #1
               x  = Shell ("tools\pbcodec_new.exe " +  Exe.Path$ + "tempfiles\gbcoderx_pbcodec.bas", 1)  'opens, does not wait for it to close

            Case %IDM_Tool_gbSearch
               x  = Shell ("tools\gbsearch.exe", 1)  'opens, does not wait for it to close

            Case %IDM_Tool_gbSearchLite
               x  = Shell ("tools\gbsearchlite.exe", 1)  'opens, does not wait for it to close

            Case %IDM_Tool_gbMagnify
               x  = Shell ("tools\gbmagnify.exe", 1)  'opens, does not wait for it to close

            Case %IDM_Tool_gbRuler
               x  = Shell ("tools\gbruler.exe", 1)  'opens, does not wait for it to close

         End Select
      Case %WM_Size : ResizeWindow

   End Select
End Function

Sub BuildAcceleratorTable
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(11)
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F1    : ac(cc).cmd  = %IDT_Help     : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F2    : ac(cc).cmd  = %IDT_ShowProcedureNames : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F3    : ac(cc).cmd  = %IDT_Search   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_F     : ac(cc).cmd  = %IDT_Search   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_L     : ac(cc).cmd  = %IDT_CopyLeft : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_N     : ac(cc).cmd  = %IDT_ShowNP   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_O     : ac(cc).cmd  = %IDT_Open     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_P     : ac(cc).cmd  = %IDT_ShowP    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_R     : ac(cc).cmd  = %IDT_Reload   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_S     : ac(cc).cmd  = %IDT_SortA    : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_T     : ac(cc).cmd  = %IDT_CallTree : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_Z     : ac(cc).cmd  = %IDM_Test     : Incr cc
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateScintillaControls
   Local style&, buf$
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
      Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop

   hLib = LoadLibrary("files\scilexer.dll")
   Control Add "Scintilla", hDlg, %IDC_ScintillaA, "", 5, 80, 280, 250, style&, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ScintillaA To hSciA

   Control Add "Scintilla", hDlg, %IDC_ScintillaB, "", 310, 80, 280, 250, style&, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ScintillaB To hSciB

   Menu New PopUp To hContextA
'   Menu Add String, hContextA, "Undo",  %IDM_Undo,  %MF_Enabled
'   Menu Add String, hContextA, "Redo",  %IDM_Redo,  %MF_Enabled
'   Menu Add String, hContextB, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextA, "Cut",  %IDM_Cut,  %MF_Enabled
   Menu Add String, hContextA, "Copy", %IDM_Copy,  %MF_Enabled
   Menu Add String, hContextA, "CopyAll", %IDM_Copyall,  %MF_Enabled
   Menu Add String, hContextA, "Paste", %IDM_Paste,  %MF_Enabled
   Menu Add String, hContextB, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextA, "Delete", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContextA, "Clear", %IDM_Clear,  %MF_Enabled
   Menu Add String, hContextA, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextA, "Load Example", %IDM_LoadExample,  %MF_Enabled
   Menu Add String, hContextA, "Send File To IDE", %IDM_OpenCFNInIDE,  %MF_Enabled
   Menu Add String, hContextA, "Send Input To IDE", %IDM_OpenAInIDE,  %MF_Enabled

   Menu New PopUp To hContextB
'   Menu Add String, hContextA, "Undo",  %IDM_Undo,  %MF_Enabled
'   Menu Add String, hContextA, "Redo",  %IDM_Redo,  %MF_Enabled
'   Menu Add String, hContextB, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextB, "Cut",  %IDM_Cut,  %MF_Enabled
   Menu Add String, hContextB, "Copy", %IDM_Copy,  %MF_Enabled
   Menu Add String, hContextB, "CopyAll", %IDM_Copyall,  %MF_Enabled
   Menu Add String, hContextB, "Paste", %IDM_Paste,  %MF_Enabled
   Menu Add String, hContextB, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextB, "Delete", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContextB, "Clear", %IDM_Clear,  %MF_Enabled
   Menu Add String, hContextB, "-", %IDM_Sep,  %MF_Enabled
   Menu Add String, hContextB, "Send Output To IDE", %IDM_OpenBInIDE,  %MF_Enabled
End Sub

Sub CreateListView
   Control Add ListView, hDlg, %IDC_ListView, "", 10,10,175,75, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ListView To hListView

   ListView Insert Column hDlg, %IDC_ListView, 1, "Procedure", 500, 0
   ListView Insert Column hDlg, %IDC_ListView, 2, "Category", 200, 0
   ListView Insert Column hDlg, %IDC_ListView, 3, "Array Pos", 100, 0
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_CheckBoxes
   Menu New PopUp To hContextLV
   Menu Add String, hContextLV, "Check All", %IDM_CheckAll, %MF_Enabled
   Menu Add String, hContextLV, "UnCheck All", %IDM_UnCheckAll, %MF_Enabled
   Menu Add String, hContextLV, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextLV, "Delete Selected", %IDM_DeleteSelected, %MF_Enabled
   Menu Add String, hContextLV, "Delete Checked", %IDM_DeleteChecked, %MF_Enabled
   Menu Add String, hContextLV, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextLV, "Build Output With Checked Procedures Only", %IDM_BuildOutputChecked, %MF_Enabled
   Menu Add String, hContextLV, "Build Output With All Procedures Only", %IDM_BuildOutputAll, %MF_Enabled
   Menu Add String, hContextLV, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextLV, "Build Output With Checked + NP", %IDM_BuildOutputCheckedNP, %MF_Enabled
   Menu Add String, hContextLV, "Build Output With All + NP", %IDM_BuildOutputAllNP, %MF_Enabled

   'create imagelist
   ImageList New Icon 16,16,24,3 To hImageListLV
   ImageList Add Icon hImageListLV, "xup"
   ImageList Add Icon hImageListLV, "xdown"
   'assign imagelist to header
   hHeader = ListView_GetHeader(hListView)
   Header_SetImageList hHeader, hImagelistLV


End Sub

Sub CreateTreeView
   Local hItem As Dword
   Control Add Treeview, hDlg, %IDC_TreeView, "",  -5000, -5000, 160, 80  , %TVS_TrackSelect Or %TVS_HasLines Or %TVS_HasButtons Or %TVS_LinesAtRoot _
       Or %TVS_ShowSelAlways Or %WS_TabStop, %WS_Ex_ClientEdge Or %WS_Ex_Left 'Or %WS_Ex_AcceptFiles
   Control Handle hDlg, %IDC_TreeView To hTree

   Menu New PopUp To hContextTV
   Menu Add String, hContextTV, "Expand All", %IDM_ExpandAll, %MF_Enabled
   Menu Add String, hContextTV, "Collapse All", %IDM_CollapseAll, %MF_Enabled
   Menu Add String, hContextTV, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextTV, "Export Tree", %IDM_ExportTree, %MF_Enabled
End Sub

Sub CreateImageList
    ImageList New Icon 24,24,24,50 To hImageListTB
    ImageList Add Icon hImageListTB, "xsortdown"  '1
    ImageList Add Icon hImageListTB, "xsortup"    '2
    ImageList Add Icon hImageListTB, "xsettings"  '3
    ImageList Add Icon hImageListTB, "xhelp"      '4
    ImageList Add Icon hImageListTB, "xnew"       '5
    ImageList Add Icon hImageListTB, "xopen"      '6
    ImageList Add Icon hImageListTB, "xshowp"     '7
    ImageList Add Icon hImageListTB, "xshowlist"  '8
    ImageList Add Icon hImageListTB, "xreload"    '9
    ImageList Add Icon hImageListTB, "xcopyleft"  '10
    ImageList Add Icon hImageListTB, "xfont"      '11
    ImageList Add Icon hImageListTB, "xshownp"    '12
    ImageList Add Icon hImageListTB, "xide"       '13
    ImageList Add Icon hImageListTB, "xsaveas"    '14
    ImageList Add Icon hImageListTB, "xall"       '15
    ImageList Add Icon hImageListTB, "xtree"      '16
    ImageList Add Icon hImageListTB, "xtreex"     '17
    ImageList Add Icon hImageListTB, "xsearch"    '18
    ImageList Add Icon hImageListTB, "xmerge"     '19
    ImageList Add Icon hImageListTB, "xtools"     '20
    ImageList Add Icon hImageListTB, "xapitree"   '21
    ImageList Add Icon hImageListTB, "xformat"    '22
    ImageList Add Icon hImageListTB, "xcopyright" '23
    ImageList Add Icon hImageListTB, "xjustify"   '24
End Sub

Sub CreateContextMenus
    Menu New PopUp To hActions
    Menu Add String, hActions, "Copy Left", %IDM_mCopyLeft, %MF_Enabled
    Menu Add String, hActions, "Copy Right", %IDM_mCopyRight, %MF_Enabled
    Menu Add String, hActions, "Left Justify Output", %IDM_mJustify, %MF_Enabled
    Menu Add String, hActions, "Format Output", %IDM_mFormat, %MF_Enabled
    Menu Add String, hActions, "Titles", %IDM_mShowProcedureNames, %MF_Enabled
    Menu Add String, hActions, "Non-Proceure Code", %IDM_mShowNP, %MF_Enabled
    Menu Add String, hActions, "Procedures", %IDM_mShowP, %MF_Enabled
    Menu Add String, hActions, "Procedures, Sorted Ascending", %IDM_mSortA, %MF_Enabled
    Menu Add String, hActions, "Procedures, Sorted Descending", %IDM_mSortD, %MF_Enabled
    Menu Add String, hActions, "Merge Includes", %IDM_mMerge, %MF_Enabled
    Menu Add String, hActions, "Call Tree", %IDM_mCallTree, %MF_Enabled
    Menu Add String, hActions, "Called By Tree", %IDM_mCallingTree, %MF_Enabled
    Menu Add String, hActions, "API Called By Tree", %IDM_mAPITree, %MF_Enabled

    Menu New PopUp To hTools
    Menu Add String, hTools, "PBReference (Brown)", %IDM_Tool_PBReference, %MF_Enabled
    Menu Add String, hTools, "PBCodec (Borje/Maddox)", %IDM_Tool_PBCodec, %MF_Enabled
    Menu Add String, hTools, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hTools, "gbSearch", %IDM_Tool_gbSearch, %MF_Enabled
    Menu Add String, hTools, "gbSearchLite", %IDM_Tool_gbSearchLite, %MF_Enabled
    Menu Add String, hTools, "gbMagnify", %IDM_Tool_gbMagnify, %MF_Enabled
    Menu Add String, hTools, "gbRuler", %IDM_Tool_gbRuler, %MF_Enabled

    Menu New PopUp To hSettings
    Menu Add String, hSettings, "Build in Ascending Procedure Order", %IDM_AscendingOrder, %MF_Enabled
    Menu Add String, hSettings, "Build in Forward Call Order", %IDM_ForwardCallOrder, %MF_Enabled
    Menu Add String, hSettings, "Build in Reverse Call Order", %IDM_ReverseCallOrder, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "PBMain As Non-Procedure", %IDM_SkipPBMain, %MF_Enabled
    Menu Add String, hSettings, "DlgProc As Non-Procedure", %IDM_SkipDlgProc, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Use Includes in Build", %IDM_UseIncludes, %MF_Enabled
    Menu Add String, hSettings, "Use Nested Includes in Build", %IDM_UseNestedIncludes, %MF_Enabled
    Menu Add String, hSettings, "Show Include Separators", %IDM_UseIncludeSeparators, %MF_Enabled
'    Menu Add String, hSettings, "Tweener As Non-Procedure", %IDM_TweenerAsNP, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Syntax Highlighting", %IDM_SyntaxHighlighting, %MF_Enabled
    Menu Add String, hSettings, "Procedure Name Highlighting", %IDM_ProcedureHighlighting, %MF_Enabled
    Menu Add String, hSettings, "API Name Highlighting", %IDM_APIHighlighting, %MF_Enabled
    Menu Add String, hSettings, "Plus Symbol in Tree Export", %IDM_PlusTree, %MF_Enabled
    Menu Add String, hSettings, "Use Speech Messages", %IDM_UseSpeech, %MF_Enabled
    Menu Add String, hSettings, "Minimal Toolbar", %IDM_MinimalToolbar, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Upper Case", %IDM_UpperCase, %MF_Enabled
    Menu Add String, hSettings, "Lower Case", %IDM_LowerCase, %MF_Enabled
    Menu Add String, hSettings, "Mixed Case", %IDM_MixedCase, %MF_Enabled

    Menu New PopUp To hHelp
    Menu Add String, hHelp, "Online Update", %IDM_OnlineUpdate, %MF_Enabled

    Menu New PopUp To hPBWin
    Menu Add String, hPBWin, "Select IDE", %IDM_SelectIDE, %MF_Enabled
End Sub

Sub CreateToolbar
   Control Kill hDlg, %IDC_Toolbar
'   CreateImageList
   If MinimalToolbar Then CreateMinimalToolbar Else CreateFullToolbar
   Control Set Font hDlg, %IDC_Toolbar, hFont
End Sub

Sub CreateFullToolbar
   Local hImageList As Dword
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageListTB, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Open, %BTNS_Button, "Open"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_New, %BTNS_Button, "Clear"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Reload, %BTNS_Button, "Reload"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_CopyLeft, %BTNS_Button, "CopyL"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 23,  %IDT_CopyRight, %BTNS_Button, "CopyR"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 14,  %IDT_SaveAs, %BTNS_Button, "Save"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 24,  %IDT_Justify, %BTNS_Button, "Justify"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 22,  %IDT_Format, %BTNS_Button, "Format"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_ShowProcedureNames, %BTNS_Button, "Titles"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 12,  %IDT_ShowNP, %BTNS_Button, "Non-Proc"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_ShowP, %BTNS_Button, "Proc"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_SortA, %BTNS_Button, "SortA"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_SortD, %BTNS_Button, "SortD"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 15,  %IDT_Build, %BTNS_Button, "Build"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 19,  %IDT_Merge, %BTNS_Button, "Merge"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 16,  %IDT_CallTree, %BTNS_Button, "Call"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 17,  %IDT_CalledTree, %BTNS_Button, "Called"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 21,  %IDT_APITree, %BTNS_Button, "API"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 13,  %IDT_OpenInIDE,  %BTNS_Button Or %BTNS_DropDown, "IDE"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 18,  %IDT_Search,  %BTNS_Button, "Find"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11,  %IDT_Font, %BTNS_Button, "Font"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 20,  %IDT_Tools,  %BTNS_Button Or %BTNS_DropDown, "Tools"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Help,  %BTNS_Button Or %BTNS_DropDown, "Help"
End Sub

Sub CreateMinimalToolbar
   Local hImageList As Dword
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageListTB, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Open, %BTNS_Button, "Open"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_New, %BTNS_Button, "Clear"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Reload, %BTNS_Button, "Reload"
'    Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_CopyLeft, %BTNS_Button, "CopyL"
'    Toolbar Add Button    hDlg, %IDC_Toolbar, 23,  %IDT_CopyRight, %BTNS_Button, "CopyR"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 14,  %IDT_SaveAs, %BTNS_Button, "SaveAs"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 15,  %IDT_Build, %BTNS_Button Or %BTNS_DropDown, "Build"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 13,  %IDT_OpenInIDE,  %BTNS_Button Or %BTNS_DropDown, "IDE"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 18,  %IDT_Search,  %BTNS_Button, "Find"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 11,  %IDT_Font, %BTNS_Button, "Font"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 20,  %IDT_Tools,  %BTNS_Button Or %BTNS_DropDown, "Tools"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Help,  %BTNS_Button Or %BTNS_DropDown, "Help"
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
'   If Debug Then Txt.Print FuncName$ ... disabled by choice
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub LoadFileNameContent
   If IsFalse(IsFile(FileName)) Then
      If UseSpeech Then
         ReadText "File does not exist."
      Else
         sndPlaySound("MailBeep", %SND_Async)    'play sound once (in the background)
      End If
      Exit Sub
   End If
   Local temp$
   Open FileName For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   SendMessage hSciA, %SCI_SetText, 0, StrPtr(temp$)
End Sub

Sub LoadFiles
   Local temp$
   '$FileIn
   If IsFile($FileIn) Then
      Open $FileIn For Binary As #1
      Get$ #1, Lof(1), temp$
      Close #1
      SendMessage hSciA, %SCI_SetText, 0, StrPtr(temp$)
   End If
   '$FileOut
   If IsFile($FileOut) Then
      Open $FileOut For Binary As #1
      Get$ #1, Lof(1), temp$
      Close #1
      SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
   End If
   '$FileOutTreeView
   If IsFile($FileOutTreeView) Then
      TreeViewCreateFromFile $FileOutTreeView
      ShowFirstLevel
   End If
   '$FileOutListView
   If IsFile($FileOutListView) Then
      ListViewCreateFromFile $FileOutListView
   End If
End Sub

Sub LoadTestProcedures
   Local temp$
   temp$ += "#Compile EXE" + $CrLf + "Dim All" + $CrLf + $CrLf
   temp$ += "#Include " + Chr$(34) + "win32api.inc" + Chr$(34) + $CrLf
   temp$ += "#Include " + Chr$(34) + "files\TestA.inc" + Chr$(34) + $CrLf
   temp$ += "#Include " + Chr$(34) + "files\testb.inc" + Chr$(34) + $CrLf
   temp$ += "#Include " + Chr$(34) + "files\testc.inc" + Chr$(34) + $CrLf + $CrLf
   temp$ += "Enum Equates Singular" + $CrLf
   temp$ += "   IDC_Label" + $CrLf + "   IDM_Copy" + $CrLf + "End Enum" + $CrLf + $CrLf
   temp$ += "Function PBMain" + $CrLf + "   Call DlgProc" + $CrLf + "End Function" + $CrLf + $CrLf
   temp$ += "Callback Function DlgProc" + $CrLf + "   Call Half : Call Alpha" + $CrLf + "End Function" + $CrLf + $CrLf
   temp$ += "Sub Half" + $CrLf + "   Call Rect" + $CrLf + "End Sub" + $CrLf + $CrLf
   temp$ += "Callback Function Alpha" + $CrLf + "   GetCursorPos" + $CrLf + "   Call GNU" + $CrLf + "End Function" + $CrLf + $CrLf
   temp$ += "'Tween Label #1" + $CrLf
   temp$ += "Function Gnu" + $CrLf + "   Call Zeta : Call MyClass" + $CrLf + "End Function" + $CrLf + $CrLf
   temp$ += "Sub Rect" + $CrLf + "   'CommentR" + $CrLf + "End Sub" + $CrLf + $CrLf
   temp$ += "Class MyClass" + $CrLf + "   SendMessage" + $CrLf + "   'No Calls" + $CrLf + "End Class" + $CrLf + $CrLf
   temp$ += "'Tween Label #2" + $CrLf
   temp$ += "Sub Zeta" + $CrLf + "   'No Calls" + $CrLf + "End Sub"
   SendMessage hSciA, %SCI_SetText, 0, StrPtr(temp$)
End Sub

Function SaveAs As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, temp$
    filter$ = "Source Code (*.bas, *.inc)" + $Nul + "*.bas;*.inc" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_PathMustExist Or %OFN_OverWritePrompt
    defaultext$ = "bas"
    Display Savefile hDlg, 100, 100, "Save Output to File", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       Dialog Set Text hDlg, "gbCodeRX  v" + $ver + Space$(10) + FileName
       Open FileName For Output As #1
       Print #1,GetSciText(hSciB);
       Close #1
    End If
End Function

Sub SaveFiles
   Local temp$
   '$FileIn
   Open $FileIn For Output As #1 : Print #1, GetSciText(hSciA); : Close #1
   '$FileOut
   Open $FileOut For Output As #1 : Print #1, GetSciText(hSciB); : Close #1
   '$FileOutTreeView
   TreeViewSaveToFile $FileOutTreeView
   '$FileOutListView
   ListViewSaveToFile $FileOutListView
End Sub

Function SciNoSelection(hSci As Dword) As Long
   Local x&, y&
   x& = SendMessage( hSci, %SCI_GetSelectionStart, 0,0)
   y& = SendMessage( hSci, %SCI_GetSelectionEnd, 0,0)
   If x& = y&  Then
      Function = %True  'no selection
   Else
      Function = %False
   End If
End Function

Function SciGetSelectedText(hSci As Dword) As String
   Local Txt As String, iLen As Long
   iLen = SendMessage( hSci, %SCI_GetSelText, 0, 0)     'get required buffer length
   Txt = String$(iLen," ") + Chr$(0)                   'size the buffer
   SendMessage hSci, %SCI_GetSelText, 0, StrPtr(Txt)  'get the text
   Function = Trim$(Txt,$Nul)
End Function

Function SelectAndOpenFile As Long
    Local startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    filter$ = "Source Code (*.bas, *.inc)" + $Nul + "*.bas;*.inc" + $Nul
    startfolder$ = IIf$(IsFile(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, "", startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       FileName = filevar$
       Dialog Set Text hDlg, "gbCodeRX  v" + $ver + Space$(10) + FileName
       LoadFileNameContent
    End If
End Function

Sub SelectIDE
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = "Select IDE"    'caption title. if "", then "Open" is displayed
    filter$ = "PBWin IDE" + $Nul + "*.exe" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfolder$ = PathIDE    'initial folder to be displayed
    If IsFile(PathIDE) Then
       startfile$ = PathIDE       'name to be used as initial selection
    Else
       startfile$ = ""
    End If
    defaultext$ = "exe"                 'default extension to append to selection if user does not enter it
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, _
                              defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then PathIDE = filevar$
End Sub

Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long, temp$
'   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts 'Or %CF_FixedPitchOnly 'OR %CF_ScreenFonts Or
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx ghHook
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFontCode
      Font New "Tahoma", FontSize, FontAttr To hFontC
      SetSciFonts
      SetSyntaxColors
      Control Set Font hDlg, %IDC_TreeView, hFontC
      Control Set Font hDlg, %IDC_ListView, hFontC
   End If
End Sub

Sub SetSciFonts
   Local fName As String
   fName = FontName + $Nul
   SendMessage hSciA, %Sci_StyleSetFont, %Style_Default, StrPtr(fName)  'default style to Courier new
   SendMessage hSciA, %SCI_StyleSetSize, %Style_Default, FontSize      'default style size to 10 points
   SendMessage hSciA, %SCI_StyleSetBold, %Style_Default, FontAttr       'default style is BOLD
   SendMessage hSciA, %Sci_StyleClearAll, 0, 0                          'set all styles to default
   SendMessage hSciA, %Sci_Colourise, 0, -1

   SendMessage hSciB, %Sci_StyleSetFont, %Style_Default, StrPtr(fName)  'default style to Courier new
   SendMessage hSciB, %SCI_StyleSetSize, %Style_Default, FontSize      'default style size to 10 points
   SendMessage hSciB, %SCI_StyleSetBold, %Style_Default, FontAttr       'default style is BOLD
   SendMessage hSciB, %Sci_StyleClearAll, 0, 0                          'set all styles to default
   SendMessage hSciB, %Sci_Colourise, 0, -1
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
'    Toolbar Set State hFloating, %IDC_ToolbarC, ByCmd %IDT_Select,    IIf(DrawMode=%Select Or DrawMode=%Move,%TBState_Checked,0) Or %TBState_Enabled
   'Menus
    Menu Set State hSettings, ByCmd %IDM_UseSpeech, UseSpeech * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_MinimalToolbar, MinimalToolbar * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_UseIncludes, UseIncludes * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_UseNestedIncludes, UseNestedIncludes * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_UseIncludeSeparators, UseIncludeSeparators * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_PlusTree, PlusTree * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_SkipPBMain, SkipPBMain * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_SkipDlgProc, SkipDlgProc * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_TweenerAsNP, TweenerAsNP * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_SyntaxHighlighting, SyntaxHighlighting * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ProcedureHighlighting, ProcedureHighlighting * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_APIHighlighting, APIHighlighting * %MFS_Checked Or %MFS_Enabled

    Menu Set State hSettings, ByCmd %IDM_AscendingOrder, IIf(ProcedureOrder=1,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ForwardCallOrder, IIf(ProcedureOrder=2,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_ReverseCallOrder, IIf(ProcedureOrder=3,1,0) * %MFS_Checked Or %MFS_Enabled

    Menu Set State hSettings, ByCmd %IDM_UpperCase, IIf(CodeCase=1,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_LowerCase, IIf(CodeCase=2,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_MixedCase, IIf(CodeCase=3,1,0) * %MFS_Checked Or %MFS_Enabled

End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "1170", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "600", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Courier New", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileName", "", FileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PathIDE", "c:\pbwin10\bin\pbedit.exe", PathIDE, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PathCompile", "c:\pbwin10\bin\pbwin.exe", PathCompile, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PathIncludePB", "c:\pbwin10\winapi\", PathIncludePB, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PathIncludeJR", "c:\pbwin10\roca\", PathIncludeJR, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SearchTerm", "Function", SearchTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ReplaceTerm", "Function", ReplaceTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "LabelList", "Output", LabelList, %Max_Path, INIFileName
      Getprivateprofilestring "All", "LabelTree", "Output", LabelTree, %Max_Path, INIFileName
      Getprivateprofilestring "All", "LabelSci", "Output", LabelSci, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "UseSpeech", "1", temp, %Max_Path, INIFileName:  UseSpeech = Val(temp)
      Getprivateprofilestring "All", "MinimalToolbar", "0", temp, %Max_Path, INIFileName:  MinimalToolbar = Val(temp)
      Getprivateprofilestring "All", "UseIncludes", "0", temp, %Max_Path, INIFileName:  UseIncludes = Val(temp)
      Getprivateprofilestring "All", "UseNestedIncludes", "0", temp, %Max_Path, INIFileName:  UseNestedIncludes = Val(temp)
      Getprivateprofilestring "All", "UseIncludeSeparators", "0", temp, %Max_Path, INIFileName:  UseIncludeSeparators = Val(temp)
      Getprivateprofilestring "All", "PlusTree", "0", temp, %Max_Path, INIFileName:  PlusTree = Val(temp)
      Getprivateprofilestring "All", "SkipPBMain", "1", temp, %Max_Path, INIFileName:  SkipPBMain = Val(temp)
      Getprivateprofilestring "All", "SkipDlgProc", "1", temp, %Max_Path, INIFileName:  SkipDlgProc = Val(temp)
      Getprivateprofilestring "All", "TweenerAsNP", "1", temp, %Max_Path, INIFileName:  TweenerAsNP = Val(temp)
      Getprivateprofilestring "All", "CodeCase", "3", temp, %Max_Path, INIFileName:  CodeCase = Val(temp)
      Getprivateprofilestring "All", "SyntaxHighlighting", "1", temp, %Max_Path, INIFileName:  SyntaxHighlighting = Val(temp)
      Getprivateprofilestring "All", "ProcedureHighlighting", "1", temp, %Max_Path, INIFileName:  ProcedureHighlighting = Val(temp)
      Getprivateprofilestring "All", "APIHighlighting", "1", temp, %Max_Path, INIFileName:  APIHighlighting = Val(temp)
      Getprivateprofilestring "All", "Layout", "0", temp, %Max_Path, INIFileName:  Layout = Val(temp)
      Getprivateprofilestring "All", "ProcedureOrder", "3", temp, %Max_Path, INIFileName:  ProcedureOrder = Val(temp)
      Getprivateprofilestring "All", "ControlType", "1", temp, %Max_Path, INIFileName:  ControlType = Val(temp)
      Getprivateprofilestring "All", "IndentSize", "3", temp, %Max_Path, INIFileName:  IndentSize = Val(temp)
      Getprivateprofilestring "All", "ManageBlankLines", "1", temp, %Max_Path, INIFileName:  ManageBlankLines = Val(temp)
      Getprivateprofilestring "All", "FixedB", "2", temp, %Max_Path, INIFileName:  FixedB = Val(temp)
      Getprivateprofilestring "All", "MaxB", "1", temp, %Max_Path, INIFileName:  MaxB = Val(temp)

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      WritePrivateProfileString "All", "PathIDE",PathIDE, INIFileName
      WritePrivateProfileString "All", "PathIncludePB",PathIncludePB, INIFileName
      WritePrivateProfileString "All", "PathIncludeJR",PathIncludeJR, INIFileName
      WritePrivateProfileString "All", "PathCompile",PathCompile, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName
      WritePrivateProfileString "All", "ReplaceTerm",ReplaceTerm, INIFileName
      WritePrivateProfileString "All", "LabelList",LabelList, INIFileName
      WritePrivateProfileString "All", "LabelTree",LabelTree, INIFileName
      WritePrivateProfileString "All", "LabelSci",LabelSci, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontAttr", Str$(FontAttr), INIFileName
      WritePrivateProfileString "All", "UseSpeech", Str$(UseSpeech), INIFileName
      WritePrivateProfileString "All", "MinimalToolbar", Str$(MinimalToolbar), INIFileName
      WritePrivateProfileString "All", "UseIncludes", Str$(UseIncludes), INIFileName
      WritePrivateProfileString "All", "UseNestedIncludes", Str$(UseNestedIncludes), INIFileName
      WritePrivateProfileString "All", "UseIncludeSeparators", Str$(UseIncludeSeparators), INIFileName
      WritePrivateProfileString "All", "PlusTree", Str$(PlusTree), INIFileName
      WritePrivateProfileString "All", "SkipPBMain", Str$(SkipPBMain), INIFileName
      WritePrivateProfileString "All", "SkipDlgProc", Str$(SkipDlgProc), INIFileName
      WritePrivateProfileString "All", "TweenerAsNP", Str$(TweenerAsNP), INIFileName
      WritePrivateProfileString "All", "CodeCase", Str$(CodeCase), INIFileName
      WritePrivateProfileString "All", "SyntaxHighlighting", Str$(SyntaxHighlighting), INIFileName
      WritePrivateProfileString "All", "ProcedureHighlighting", Str$(ProcedureHighlighting), INIFileName
      WritePrivateProfileString "All", "APIHighlighting", Str$(APIHighlighting), INIFileName
      WritePrivateProfileString "All", "Layout", Str$(Layout), INIFileName
      WritePrivateProfileString "All", "ProcedureOrder", Str$(ProcedureOrder), INIFileName
      WritePrivateProfileString "All", "ControlType", Str$(ControlType), INIFileName
      WritePrivateProfileString "All", "IndentSize", Str$(IndentSize), INIFileName
      WritePrivateProfileString "All", "ManageBlankLines", Str$(ManageBlankLines), INIFileName
      WritePrivateProfileString "All", "FixedB", Str$(FixedB), INIFileName
      WritePrivateProfileString "All", "MaxB", Str$(MaxB), INIFileName

   End If
End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Open        : Function = "Open Source Code File"
      Case %IDT_New         : Function = "Clear Input/Output"
      Case %IDT_Reload      : Function = "Reload Current Source File"
      Case %IDT_CopyLeft    : Function = "Copy Output to Input"
      Case %IDT_CopyRight   : Function = "Copy Input to Output"
      Case %IDT_SaveAs      : Function = "Save Output to File"

      Case %IDT_Justify     : Function = "Left Justify Output Selection (All If No Selection)"
      Case %IDT_Format      : Function = "Format Output Selection (All If No Selection)"
      Case %IDT_ShowProcedureNames : Function = "Display Procedure Titles"
      Case %IDT_ShowNP      : Function = "Display Non-Procedure Code (Un-Sorted)"
      Case %IDT_ShowP       : Function = "Display Procedure Code (Un-Sorted)"
      Case %IDT_SortA       : Function = "Display Procedures (Sorted Ascending)"
      Case %IDT_SortD       : Function = "Display Procedures (Sorted Descending)"
      Case %IDT_Build       : Function = "Build Complete Code Listing (Non-Procedure and Procedure Code) From Input"
      Case %IDT_Merge       : Function = "Append Main Code and All Includes"
      Case %IDT_CallTree    : Function = "List of Procedures and Procedures Called by Those Procedures"
      Case %IDT_CalledTree : Function = "List of Procedures and Procedures Which Call Those Procedures"
      Case %IDT_APITree     : Function = "List of Used API and Procedures Which Use Them"
      Case %IDT_Search      : Function = "Open Find Dialog (Searches INPUT)"
      Case %IDT_OpenInIDE   : Function = "Open Input in IDE"
      Case %IDT_Font        : Function = "Select Font for Code Display"
      Case %IDT_Settings    : Function = "Settings"
      Case %IDT_Help        : Function = "Online Help"
   End Select
End Function

Sub InitializeKeyWords
   Local temp$, i As Long
   ReDim KeyWords(1000)
   Open Exe.Path$ + "files\powerbasic_keywords.txt" For Input As #1
   While IsFalse Eof(1)
     Line Input #1, temp$
     If Len(Trim$(temp$)) Then KeyWords(i) = LCase$(temp$) : Incr i
   Wend
   Close #1
   ReDim Preserve KeyWords(i-1)
End Sub

Sub SetCodeStyle
    Select Case CodeCase
        Case 1
           SendMessage hSciA, %Sci_StyleSetCase, %Style_Keywords, %SC_Case_Upper
           SendMessage hSciB, %Sci_StyleSetCase, %Style_Keywords, %SC_Case_Upper
        Case 2
           SendMessage hSciA, %Sci_StyleSetCase, %Style_Keywords, %SC_Case_Lower
           SendMessage hSciB, %Sci_StyleSetCase, %Style_Keywords, %SC_Case_Lower
        Case 3
           SendMessage hSciA, %Sci_StyleSetCase, %Style_Keywords, %SC_Case_Mixed
           SendMessage hSciB, %Sci_StyleSetCase, %Style_Keywords, %SC_Case_Mixed
    End Select
End Sub

Sub InitializeSci
   Local KeyWords As String, i As Long, hSci As Dword
   For i = 1 To 2
      If i = 1 Then hSci = hSciA Else hSci = hSciB
      'set margins
      SendMessage hSci, %SCI_SetMarginWidthN, 0,                 40    'display Line numbers
      SendMessage hSci, %SCI_SetMarginWidthN, 1,                 5    'defaults to non-folding symbols

      'set lexer to VB
      SendMessage hSci, %SCI_SETLEXER, %SCLEX_VB, 0    'built-in PB lexer has bugs, so this snippet uses VB  %SCLEX_PowerBASIC
      KeyWords = Join$(KeyWords(),$Spc)
      SendMessage hSci, %SCI_SETKEYWORDS, 0, ByVal StrPtr(KeyWords) 'define PB keywords
      SendMessage hSci, %SCI_SETKEYWORDS, 1, ByVal StrPtr(ProcedureWords) 'define proceduren names
      SendMessage hSci, %SCI_SETKEYWORDS, 2, ByVal StrPtr(APISearchList) 'define api names
   Next i
End Sub

Sub SetSyntaxColors
   Local i As Long, hSci As Dword
   For i = 1 To 2
      If i = 1 Then hSci = hSciA Else hSci = hSciB
      If SyntaxHighlighting Then
         'set syntax highlighting colors
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_KEYWORD,    %Blue
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_STRING,     %rgb_DarkRed
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_NUMBER,     %Black
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_COMMENT,    %rgb_DarkGreen
      Else
         'turn off syntax highlighting colors
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_KEYWORD,    %Black
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_STRING,     %Black
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_NUMBER,     %Black
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_COMMENT,    %Black
      End If

      If ProcedureHighlighting Then
         'set syntax highlighting colors for Procedure Names
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_KEYWORD2,   %rgb_Red
         SendMessage hSci, %SCI_STYLESETBACK,    %SCE_B_KEYWORD2,   %Yellow
      Else
         'turn off syntax highlighting colors for Procedure Names
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_KEYWORD2,   %Black
         SendMessage hSci, %SCI_STYLESETBACK,    %SCE_B_KEYWORD2,   %White
      End If

      If APIHighlighting Then
         'set syntax highlighting colors for Procedure Names
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_KEYWORD3,   %Red
         SendMessage hSci, %SCI_STYLESETBACK,    %SCE_B_KEYWORD3,   %rgb_Wheat
      Else
         'turn off syntax highlighting colors for Procedure Names
         SendMessage hSci, %SCI_STYLESETFORE,    %SCE_B_KEYWORD3,   %Black
         SendMessage hSci, %SCI_STYLESETBACK,    %SCE_B_KEYWORD3,   %White
      End If


   Next i
End Sub

Function GetSciText(hScintilla As Dword) As String
   Local Txt As String, nChars As Long
   nChars  = SendMessage( hScintilla, %SCI_GetLength, 0, 0)     'get #chars
   Txt = String$(nChars+1," ")
   SendMessage hScintilla, %SCI_GetText , nChars+1, StrPtr(Txt)  'retrieve #chars into txt
   Function = RTrim$(Txt,$Nul)
End Function

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Select Case Layout
      Case 0   'Both A and B
         Control Set Loc hDlg, %IDC_LabelA, 5, 55
         Control Set Loc hDlg, %IDC_LabelB, w/2+5, 55
         Control Set Loc hDlg, %IDC_ScintillaA, 5, 80
         Control Set Size hDlg, %IDC_ScintillaA, w/2 - 10, h - 85
         Control Set Size hDlg, %IDC_ScintillaB, w/2 - 10, h - 85
         Control Set Size hDlg, %IDC_TreeView, w/2 - 10, h - 85
         Control Set Size hDlg, %IDC_ListView, w/2 - 10, h - 85
         Select Case ControlType
            Case %cListView
               Control Set Loc hDlg, %IDC_ScintillaB, -5000, -5000
               Control Set Loc hDlg, %IDC_TreeView, -5000, -5000
               Control Set Loc hDlg, %IDC_ListView, w/2+5, 80
            Case %cTreeView
               Control Set Loc hDlg, %IDC_ScintillaB, -5000, -5000
               Control Set Loc hDlg, %IDC_ListView, -5000, -5000
               Control Set Loc hDlg, %IDC_TreeView, w/2+5, 80
            Case %cScintilla
               Control Set Loc hDlg, %IDC_TreeView, -5000, -5000
               Control Set Loc hDlg, %IDC_ListView, -5000, -5000
               Control Set Loc hDlg, %IDC_ScintillaB, w/2+5, 80
         End Select
      Case 1   'A only
         Control Set Loc hDlg, %IDC_LabelA, 5, 55
         Control Set Loc hDlg, %IDC_ScintillaA, 5, 80
         Control Set Loc hDlg, %IDC_LabelB, -5000, -5000
         Control Set Loc hDlg, %IDC_ScintillaB, -5000, -5000
         Control Set Loc hDlg, %IDC_TreeView, -5000, -5000
         Control Set Loc hDlg, %IDC_ListView, -5000, -5000
         Control Set Size hDlg, %IDC_ScintillaA, w - 10, h - 85
      Case 2   'B only
         Control Set Loc hDlg, %IDC_LabelA, -5000, -5000
         Control Set Loc hDlg, %IDC_ScintillaA, -5000, -5000
         Control Set Loc hDlg, %IDC_LabelB, 5, 55
         Control Set Size hDlg, %IDC_ScintillaB, w - 10, h - 85
         Control Set Size hDlg, %IDC_TreeView, w - 10, h - 85
         Control Set Size hDlg, %IDC_ListView, w - 10, h - 85
         Select Case ControlType
            Case %cListView
               Control Set Loc hDlg, %IDC_ScintillaB, -5000, -5000
               Control Set Loc hDlg, %IDC_TreeView, -5000, -5000
               Control Set Loc hDlg, %IDC_ListView, 5, 80
            Case %cTreeView
               Control Set Loc hDlg, %IDC_ScintillaB, -5000, -5000
               Control Set Loc hDlg, %IDC_ListView, -5000, -5000
               Control Set Loc hDlg, %IDC_TreeView, 5, 80
            Case %cScintilla
               Control Set Loc hDlg, %IDC_TreeView, -5000, -5000
               Control Set Loc hDlg, %IDC_ListView, -5000, -5000
               Control Set Loc hDlg, %IDC_ScintillaB, 5, 80
         End Select
   End Select
   Control Get Size hDlg, %IDC_ListView To w,h
   If w > 200 Then
      ListView Set Column hDlg, %IDC_ListView, 1, w-100
      ListView Set Column hDlg, %IDC_ListView, 2, 96
   Else
      ListView Set Column hDlg, %IDC_ListView, 1, 200
      ListView Set Column hDlg, %IDC_ListView, 2, 100
   End If
End Sub

Sub RemoveElement(iPos As Long)
   Array Delete Procedures(iPos)
   Array Delete ProcedureInside(iPos)
   Array Delete ProcedureData(iPos)
   ReDim Preserve Procedures(UBound(Procedures)-1)
   ReDim Preserve ProcedureInside(UBound(ProcedureInside)-1)
   ReDim Preserve ProcedureData(UBound(ProcedureData)-1)
End Sub

Sub BuildOutputs
   Local tmp$,temp$,code$,CodeArrayN(), CodeArrayLC() As String, i,ICount,PCount,Flag,FlagH As Long
   NPCode = "" : PCount = -1 : ICount = -1
   ReDim Procedures(0), ProcedureInside(0), ProcedureData(0), Includes(0)
   PBMainIndex = -1 : DlgProcIndex = -1 : ProcedureWords = ""
   ReDim Includes(200)

   'put hSciA source code in CodeArrayN() and CodeArrayLC()
   code$ = GetSciText(hSciA)
   ReDim CodeArrayN(ParseCount(code$,$CrLf)-1)
   ReDim CodeArrayLC(UBound(CodeArrayN))
   Parse code$, CodeArrayN(), $CrLf
   Parse LCase$(code$), CodeArrayLC(), $CrLf

   If UseIncludes Then
      'find 1st level list of includes - those found in INPUT code listing
      For i = 0 To UBound(CodeArrayLC)
         If Left$(CodeArrayLC(i),8) = "#include" Then
            temp$ = Trim$(Parse$(CodeArrayLC(i),Chr$(34),2))

'            If IsFalse(IsFile(temp$)) Then Exit If

            tmp$ = $Spc + PathName$(Namex,temp$) + $Spc
            If InStr(SkipList,tmp$)  Then Exit If

            Incr ICount
            ReDim Preserve Includes(ICount)
            Includes(ICount) = Parse$(CodeArrayN(i),Chr$(34),2)
         End If
      Next i
      If iCount > -1 Then
         ReDim Preserve Includes(iCount)
         GetIncludesCode  'build nested include file list and put code into variable IncludesCode
      End If
      're-build CodeArrayLC() and CodeArrayN() if includes are used/found
      If ICount > -1 Then
         code$ = code$ + $CrLf + $CrLf + IncludesCode
         ReDim CodeArrayN(ParseCount(code$,$CrLf)-1)
         ReDim CodeArrayLC(UBound(CodeArrayN))
         Parse code$, CodeArrayN(), $CrLf
         Parse LCase$(code$), CodeArrayLC(), $CrLf
      End If
   End If

   'extract Sub/Function code
   For i = 0 To UBound(CodeArrayLC)
      FlagH = 0
      'detect beginning of procedures
      If Left$(CodeArrayLC(i),8) = "callback" Then
         Flag = 1 : FlagH = 1 : Incr PCount : ReDim Preserve Procedures(PCount), ProcedureInside(PCount), ProcedureData(PCount)
         temp$ = CodeArrayN(i)
         Replace "(" With $Spc In temp$
         tmp$ = Parse$(temp$,$Spc,3)
         If LCase$(tmp$) = "dlgproc" Then DlgProcIndex = PCount
         ProcedureData(PCount).name = tmp$
         ProcedureWords += LCase$(tmp$) + $Spc
         ProcedureData(PCount).cat = "CallBack"
         ProcedureData(PCount).ipos = PCount
      ElseIf Left$(CodeArrayLC(i),8) = "function" Then
         Flag = 1 : FlagH = 1 : Incr PCount : ReDim Preserve Procedures(PCount), ProcedureInside(PCount), ProcedureData(PCount)
         temp$ = CodeArrayN(i)
         Replace "(" With $Spc In temp$
         tmp$ = Parse$(temp$,$Spc,2)
         If LCase$(tmp$) = "pbmain" Then PBMainIndex = PCount
         ProcedureData(PCount).name = tmp$
         ProcedureWords += LCase$(tmp$) + $Spc
         ProcedureData(PCount).cat = "Function"
         ProcedureData(PCount).ipos = PCount
      ElseIf Left$(CodeArrayLC(i),3) = "sub"      Then
         Flag = 1 : FlagH = 1 : Incr PCount : ReDim Preserve Procedures(PCount), ProcedureInside(PCount), ProcedureData(PCount)
         temp$ = CodeArrayN(i)
         Replace "(" With $Spc In temp$
         tmp$ = Parse$(temp$,$Spc,2)
         ProcedureData(PCount).name = tmp$
         ProcedureWords += LCase$(tmp$) + $Spc
         ProcedureData(PCount).cat = "Sub"
         ProcedureData(PCount).ipos = PCount
      ElseIf Left$(CodeArrayLC(i),5) = "class"    Then
         Flag = 1 : FlagH = 1 : Incr PCount : ReDim Preserve Procedures(PCount), ProcedureInside(PCount), ProcedureData(PCount)
         temp$ = CodeArrayN(i)
         Replace "(" With $Spc In temp$
         tmp$ = Parse$(temp$,$Spc,2)
         ProcedureData(PCount).name = tmp$
         ProcedureWords += LCase$(tmp$) + $Spc
         ProcedureData(PCount).cat = "Class"
         ProcedureData(PCount).ipos = PCount

      End If
      'put line of code in P or NP as appropriate
      If Flag = 0 Then NPCode += CodeArrayN(i) + $CrLf
      If Flag = 1 Then Procedures(PCount) += CodeArrayN(i) + $CrLf

      'capture inside only
      If Left$(CodeArrayLC(i),12) = "end function" Then FlagH = 1
      If Left$(CodeArrayLC(i),7) = "end sub"       Then FlagH = 1
      If Left$(CodeArrayLC(i),9) = "end class"     Then FlagH = 1

      If (PCount > -1) And (FlagH = 0) Then ProcedureInside(PCount) += CodeArrayN(i) + $CrLf : FlagH = 0

      'IF TweenerAsNP Then
         'reset flag at end of procedure
         If Flag And Left$(CodeArrayLC(i),12) = "end function" Then Flag = 0 : Procedures(PCount) += $CrLf
         If Flag And Left$(CodeArrayLC(i),7) = "end sub"       Then Flag = 0 : Procedures(PCount) += $CrLf
         If Flag And Left$(CodeArrayLC(i),9) = "end class"     Then Flag = 0 : Procedures(PCount) += $CrLf
      'End IF

   Next i

   'if required, place PBMain and DlgProc into NP and remove from arrays (if present)
   If (ProcedureOrder=1) And (ControlType = %cScintilla) And (SkipPBMain=1) And (SkipDlgProc=1) And (PBMainIndex > -1) And (DlgProcIndex > -1) Then
      NPCode = NPCode + $CrLf + Procedures(PBMainIndex) + $CrLf + Procedures(DlgProcIndex)
      If PBMainIndex > DlgProcIndex Then
         RemoveElement(PBMainIndex) : RemoveElement(DlgProcIndex)
      Else
         RemoveElement(DlgProcIndex) : RemoveElement(PBMainIndex)
      End If
   ElseIf (ProcedureOrder=1) And SkipPBMain And (PBMainIndex > -1) Then
      NPCode = NPCode + $CrLf + Procedures(PBMainIndex)
      RemoveElement(PBMainIndex)
   ElseIf (ProcedureOrder=1) And SkipDlgProc And (DlgProcIndex > -1 )Then
      NPCode = NPCode + $CrLf + Procedures(DlgProcIndex)
      RemoveElement(DlgProcIndex)
   End If

   'no more than 1 contiguous NP blank line (line with only spaces not treated as blank line)
   While InStr(NPCode, $CrLf + $CrLf + $CrLf)
      Replace $CrLf + $CrLf + $CrLf With $CrLf + $CrLf In NPCode
   Wend
   NPCode = Trim$(NPCode, Any $CrLf + $Spc)

   'use ProcedureWords to reset Keywords2
   SendMessage hSciA, %SCI_SETKEYWORDS, 1, ByVal StrPtr(ProcedureWords) 'define PB keywords
   SendMessage hSciB, %SCI_SETKEYWORDS, 1, ByVal StrPtr(ProcedureWords) 'define PB keywords
End Sub

Sub BuildInReverseCallorder
   Local temp$, PBMainCode As String, iMax,i,j,k,pCount As Long
   Local WordChar, NonWordChar As String
   WordChar = Chr$(48 To 57, 65 To 90, 97 To 122)
   NonWordChar = Chr$(0 To 47, 58 To 64, 91 To 96, 123 To 128)

   'get PBMainIndex (sorting messed it up, so have to re-find) - PBMain is required
   iMax = UBound(Procedures)
   PBMainIndex = -1
   For i = 0 To iMax
      If Left$(LCase$(ProcedureData(i).name),6) = "pbmain" Then PBMainIndex = i : Exit For
   Next i
   If PBMainIndex = -1 Then
      temp$ = "PBMain not found"
      SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
      Beep : Exit Sub
   End If

   'working array ReverseCallResults(), which will be put in hSciB
   ReDim ReverseCallResults(iMax), ReverseCallResultsN(iMax)
   For i = 0 To UBound(ProcedureData()) : ProcedureData(i).used = 0 : Next i
   pCount = iMax  'currently use max location in Result()
   ReverseCallResults(iMax) = Procedures(PBMainIndex)  'last/bottom entry will be PBMain()
   ReverseCallResultsN(iMax) = PBMainIndex
   ProcedureData(PBMainIndex).used = 1

   'put all procedures into Result() in Reverse Call order
   For i = iMax To 0 Step -1       'From bottom of Results() to top
      ScanProcedureText(ReverseCallResultsN(i),pCount)  'for each word found, if word is Procedure, put procedure in Results()
   Next i

'   'add all unused procedures
   For i = iMax To 0 Step -1
      If ProcedureData(i).used = 0 Then
         Decr pCount
         ReverseCallResults(pCount) = Procedures(i)
      End If
   Next i

   'put into Scintilla
    temp$ = Trim$(NPCode + $CrLf + $CrLf + Join$(ReverseCallResults(), ""), Any $CrLf + $Spc)
    SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
End Sub

Sub BuildInForwardCallorder
   Local temp$, PBMainCode As String, iMax,i,j,k,pCount As Long
   Local WordChar, NonWordChar As String
   WordChar = Chr$(48 To 57, 65 To 90, 97 To 122)
   NonWordChar = Chr$(0 To 47, 58 To 64, 91 To 96, 123 To 128)

   'get PBMainIndex (sorting messed it up, so have to re-find) - PBMain is required
   iMax = UBound(Procedures)
   PBMainIndex = -1
   For i = 0 To iMax
      If Left$(LCase$(ProcedureData(i).name),6) = "pbmain" Then PBMainIndex = i : Exit For
   Next i
   If PBMainIndex = -1 Then
      temp$ = "PBMain not found"
      SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
      Beep : Exit Sub
   End If

   'working array ReverseCallResults(), which will be put in hSciB
   ReDim ReverseCallResults(iMax), ReverseCallResultsN(iMax)
   For i = 0 To UBound(ProcedureData()) : ProcedureData(i).used = 0 : Next i
   pCount = 0  'currently use max location in Result()
   ReverseCallResults(0) = Procedures(PBMainIndex)  'last/bottom entry will be PBMain()
   ReverseCallResultsN(0) = PBMainIndex
   ProcedureData(PBMainIndex).used = 1



   'put all procedures into Result() in Reverse Call order
   For i = 0 To iMax      'From Top of Results() to top
      ScanProcedureText(ReverseCallResultsN(i),pCount)  'for each word found, if word is Procedure, put procedure in Results()
   Next i

'   'add all unused procedures
   For i = 0 To iMax
      If ProcedureData(i).used = 0 Then
         Incr pCount
         ReverseCallResults(pCount) = Procedures(i)
      End If
   Next i

   'put into Scintilla
    temp$ = Trim$(NPCode + $CrLf + $CrLf + Join$(ReverseCallResults(), ""), Any $CrLf + $Spc)
    SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
End Sub

Function ScanProcedureText(iProc As Long, pCount As Long) As String
  Local temp$, Intext$
  Local xWord,Buf,UCBuf As String
  Local i,j,StopPos,lnLen,Result,S As Long
  Local wFlag As Byte, Letter As Byte Ptr

  InText$ = Procedures(iProc)
  temp$ = ".."

  For J = 0 To ParseCount(InText$, $CrLf)-1
     Buf = Parse$(InText$,$CrLf,J)
     UCBuf = UCase$(Buf) + $Spc
     If Len(Trim$(UCBuf))=0 Then Iterate For
     lnLen = Len(UCBuf$)
     Letter = StrPtr(UCBuf) : wFlag = 0
     For I = 1 To Len(UCBuf)
        Select Case @Letter
           Case 97 To 122, 65 To 90, 192 To 214, 216 To 246, 248 To 255,35 To 38, 48 To 57, 63, 95 'word characters
              If wFlag = 0 Then wFlag = 1 : stopPos = I
           Case 34 'string quotes -> "
             stopPos = InStr(I + 1, UCBuf, Chr$(34)) 'Find match
             If stopPos Then
                StopPos = (StopPos - I + 1)
                I = I + StopPos
                Letter = Letter + StopPos
                wFlag = 0
             End If
           Case 39 'comment character -> '
              wFlag = 0
              Exit For
           Case Else  'word is ready
              If wFlag = 1 Then
                 xWord = Mid$(Buf, stopPos, I - stopPos)  'Get word
                 If xWord = "REM" Then wFlag = 0 : Exit For
                 wFlag = 0
                 '--- do something with the word here ---
                 Result = -1
                 For S = 0 To UBound(ProcedureData)
                    If LCase$(ProcedureData(S).name) = LCase$(xWord) Then Result = S : Exit For
                 Next S
                 If Result > -1 Then
                    If InStr(LCase$(temp$), ".." + LCase$(ProcedureData(Result).name) + "..") = 0 Then
                       temp$ += ProcedureData(Result).name + ".."
                    End If
                    If (ProcedureData(Result).used = 0) And (pCount>-1)Then
                       pCount += IIf(ProcedureOrder=2,1,-1)  'Incr/Decr depending on Forward/Reverse call direction
                       ReverseCallResults(pCount) = Procedures(Result) 'put procedure into output array Result()
                       ReverseCallResultsN(pCount) = Result 'pointer back to Procedures
                       ProcedureData(Result).used = 1   'mark procedure as Used
                    End If
                 End If
                 '---------------------------------------
              End If
        End Select
        Incr Letter
     Next I
  Next J
  Function = Trim$(temp$,"..")
End Function

Sub ShowFirstLevel
   Local hNode As Dword
   Treeview Get Root hDlg, %IDC_TreeView To hNode
   Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %True
   Treeview Get Child hDlg, %IDC_TreeView, hNode To hNode
   While hNode
      Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %False
      Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
   Wend
End Sub

Sub TreeNodeExpand(ByVal hNode As Dword, Flag&)
   'Flag& = %True-Expand,  %False-Collapse
   Local iReturn As Dword, hStartNode As Dword
   hStartNode = hNode
   Do
      Treeview Set Expanded hDlg, %IDC_TreeView, hNode, Flag&    '%True-Expand,  %False-Collapse
      Treeview Get Child hDlg, %IDC_TreeView, hNode To iReturn                    'get child (1st choice)
      If iReturn = 0 Then Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn 'or sibling (2nd choice)
      If iReturn = 0 Then                                               'no child or sibling
         Do      'get sibling of first parent with sibling
            Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode            'parent
            If hNode = hStartNode Then iReturn = 0 : Exit Loop                              'if reach starting node, stop
            Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn            'sibling child of parent
         Loop Until iReturn Or (hNode = 0)  'stop when find sibling of parent with sibling, or no more choices
      End If
      hNode = iReturn    'possible values: 0, zero (no parent/no sibling), <>0 (parent or sibling)
   Loop While hNode
End Sub

Function WalkToEndOfTree(ByVal hNode As Dword, ProcedureCallList() As String) As Dword
   Local i,j,Result As Long, iReturn, hTemp, hChild As Dword, temp$
   Do
      Function = hNode
      Treeview Get Child hDlg, %IDC_TreeView, hNode To iReturn                      'get child (1st choice)
      If iReturn = 0 Then Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn   'or sibling (2nd choice)
      If iReturn = 0 Then                                                        'no child or sibling
         Do                                                                      'get sibling of first parent with sibling
            Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode              'parent
            Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn              'sibling child of parent
         Loop Until iReturn Or (hNode = 0)  'stop when find sibling of parent with sibling, or no more choices
      End If
      hNode = iReturn    'possible values: 0, zero (no parent/no sibling), <>0 (parent or sibling)
      'do something here-----------
         'add this nodes child to this node
         Treeview Get Child hDlg, %IDC_TreeView, hNode To hChild
         If hChild = 0 Then
            'add children (procedures called by this procedure)
            Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
            For i = 0 To UBound(ProcedureData)
               If LCase$(ProcedureData(i).name) = LCase$(temp$) Then
                  For j = 2 To ParseCount(ProcedureCallList(i),"..")
                     Treeview Insert Item hDlg, %IDC_TreeView, hNode, %TVI_Last, 0, 0, Parse$(ProcedureCallList(i),"..",j) To hTemp
                  Next i
                  Exit For
               End If
            Next i
         End If
      'do something here-----------
   Loop While hNode
End Function

Sub BuildCallTree
   Local z,x,y,w As Long, hRoot,hItem,hTemp As Long
   Dim ProcedureCallList(UBound(Procedures)) As String

   'Standard outputs
   BuildOutputs
   Array Sort ProcedureData(), Collate UCase, TagArray Procedures(), Ascend    'sort Title() but with Procedures() as a tag-along array

   'Build TreeView, Levels 1 & 2
   Treeview Reset hDlg, %IDC_TreeView
   Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 0, 0, "Call Tree  (" + LCase$(PathName$(Namex,FileName)) + ")" To hItem
   Treeview Get Root hDlg, %IDC_TreeView To hRoot
   For x = 0 To UBound(ProcedureData)
      If Len(ProcedureData(x).name) Then
         Treeview Insert Item hDlg, %IDC_TreeView, hRoot, %TVI_Last, 0, 0, ProcedureData(x).name To hItem
         ProcedureCallList(x) = ScanProcedureText(x,-1)  'for each word found, if word is Procedure, put procedure in Results()
         For y = 2 To ParseCount(ProcedureCallList(x),"..")
            Treeview Insert Item hDlg, %IDC_TreeView, hItem, %TVI_Last, 0, 0, Parse$(ProcedureCallList(x),"..",y) To hTemp
         Next y
      End If
   Next x
   'Build TreeView, Levels > 2
   Treeview Select hDlg, %IDC_TreeView, hRoot
   WalkToEndOfTree hRoot, ProcedureCallList()

   'Show only first child level
   ShowFirstLevel
End Sub

Sub FindSelectedProcedureCalls
   Local i,j,k,Result As Long, iReturn, hRoot,hTemp, hNode,hParent As Dword, temp$, SelectedNode$, ParentList$
   ParentList$ = ".."
   'get name of selected procedure
   Treeview Get Root hDlg, %IDC_TreeView To hRoot
   Treeview Get Select hDlg, %IDC_Treeview To hTemp
   If hTemp = 0 Then Beep : Exit Sub
   Treeview Get Text hDlg, %IDC_TreeView, hTemp To SelectedNode$
   'find parents of that procedure
   Do
      Treeview Get Child hDlg, %IDC_TreeView, hNode To iReturn                      'get child (1st choice)
      If iReturn = 0 Then Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn   'or sibling (2nd choice)
      If iReturn = 0 Then                                                        'no child or sibling
         Do                                                                      'get sibling of first parent with sibling
            Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode              'parent
            Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn              'sibling child of parent
         Loop Until iReturn Or (hNode = 0)  'stop when find sibling of parent with sibling, or no more choices
      End If
      hNode = iReturn    'possible values: 0, zero (no parent/no sibling), <>0 (parent or sibling)
      'do something here-----------
         Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
         If LCase$(temp$) = LCase$(SelectedNode$) Then
            Treeview Get Parent hDlg, %IDC_TreeView, hNode To hParent
            If (hParent<>0) And (hParent<>hRoot) Then  'add parent to parent list, if not already there
               Treeview Get Text hDlg, %IDC_TreeView, hParent To temp$
               If InStr(LCase$(ParentList$), ".." + LCase$(temp$) + "..") = 0 Then
                  ParentList$ += temp$ + ".."
               End If
            End If
         End If
      'do something here-----------
   Loop While hNode

   'fill Treeview with results
   Treeview Reset hDlg, %IDC_TreeView
   Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 0, 0, SelectedNode$ + " is called by ..." To hRoot
   For i = 1 To ParseCount(ParentList$,"..")
      temp$ = Parse$(ParentList$,"..",i)
      If Len(temp$) Then Treeview Insert Item hDlg, %IDC_TreeView, hRoot, %TVI_Last, 0, 0, temp$ To hTemp
   Next i
   ShowFirstLevel
End Sub

Sub BuildCallingTree
   Local z,x,y,w As Long, hRoot,hItem,hTemp As Long
   Dim ProcedureCallList(UBound(Procedures)) As String

   'Standard outputs
   Array Sort ProcedureData(), Collate UCase, TagArray Procedures(), Ascend    'sort Title() but with Procedures() as a tag-along array

   'Build TreeView, Levels 1
   Treeview Reset hDlg, %IDC_TreeView
   Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 0, 0, "Called By Tree  (" + LCase$(PathName$(Namex,FileName)) + ")" To hItem
   Treeview Get Root hDlg, %IDC_TreeView To hRoot
   For x = 0 To UBound(ProcedureData)
      If Len(ProcedureData(x).name) Then
         ProcedureCallList(x) = ScanProcedureText(x,-1)  'for each word found, if word is Procedure, put procedure in Results()
      End If
   Next x

   'Build TreeView, Levels > 2
   For x = 0 To UBound(ProcedureData)
      If Len(ProcedureData(x).name) Then
         Treeview Insert Item hDlg, %IDC_TreeView, hRoot, %TVI_Last, 0, 0, ProcedureData(x).name To hItem
         For y = 0 To UBound(ProcedureCallList)
            If InStr(LCase$(ProcedureCallList(y)),LCase$(ProcedureData(x).name)) Then
               If LCase$(Parse$(ProcedureCallList(y),"..",1)) <> LCase$(ProcedureData(x).name) Then
                  Treeview Insert Item hDlg, %IDC_TreeView, hItem, %TVI_Last, 0, 0, Parse$(ProcedureCallList(y),"..",1) To hTemp
               End If
            End If
         Next y
      End If
   Next x

   'Show only first child level
   Treeview Select hDlg, %IDC_TreeView, hRoot
   ShowFirstLevel
End Sub

Sub TreeViewSaveToFile(sFileName$)
   Local iLevel As Long, temp$, iUser&, iReturn As Dword, hNode As Dword, LevelHandle() As Long, D$
   Dim LevelHandle(-1 To 100)
   D$ = "++" + "--" + ";;"

   'Open file for output
   Open sFileName$ For Output As #1

   'get root node info from tree (top of tree)
   Treeview Get Root hDlg, %IDC_TreeView To hNode
   iLevel = 0
   Treeview Get User hDlg, %IDC_TreeView, hNode To iUser&
   Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
   Print #1, Str$(iLevel) + $CrLf + Str$(iUser&) + $CrLf + temp$
   LevelHandle(0) = hNode

   'walk through rest of tree
   Do
      Treeview Get Child hDlg, %IDC_TreeView, hNode To iReturn                    'get child (1st choice)
      If iReturn Then Incr iLevel 'new level
      If iReturn = 0 Then Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn 'or sibling (2nd choice)
      If iReturn = 0 Then                                               'no child or sibling
         Do      'get sibling of first parent with sibling
            Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode            'parent
            Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn            'sibling child of parent
            Decr iLevel  'dropped one level
         Loop Until iReturn Or (hNode = 0)  'stop when find sibling of parent with sibling, or no more choices
      End If
      hNode = iReturn    'possible values: 0, zero (no parent/no sibling), <>0 (parent or sibling)
      'get info from tree
      If hNode Then
         Treeview Get User hDlg, %IDC_TreeView, hNode To iUser&
         Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
         Print #1, D$ + $CrLf + Str$(iLevel) + $CrLf + Str$(iUser&) + $CrLf + temp$
         LevelHandle(iLevel) = hNode
      End If
   Loop While hNode

   Close #1
End Sub

Sub ListViewSaveToFile(sFileName$)
   Local i,iCount,iChecked As Long, tempA$, tempB$, tempC$
   Open sFileName$ For Output As #1
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, i, 1 To tempA$
      ListView Get Text hDlg, %IDC_ListView, i, 2 To tempB$
      ListView Get Text hDlg, %IDC_ListView, i, 3 To tempC$
      iChecked = ListView_GetCheckState(hListView, i-1)
      Print #1, tempA$ + "::::" + tempB$ + "::::" + tempC$ + "::::" + Str$(iChecked)
   Next i
   Close #1
End Sub

Sub ListViewCreateFromFile(sFileName$)
   Local temp$, iCount,iChecked As Long
   ListView Reset hDlg, %IDC_ListView
   Open sFileName$ For Input As #1
   While Not Eof(1)
      Line Input #1, temp$
      If Len(Trim$(temp$)) Then
         Incr iCount
         ListView Insert Item hDlg, %IDC_ListView, iCount, 0, Parse$(temp$,"::::", 1)
         ListView Set Text hDlg, %IDC_ListView, iCount, 2, Parse$(temp$,"::::",2)
         ListView Set Text hDlg, %IDC_ListView, iCount, 3, Parse$(temp$,"::::",3)
         ListView_SetCheckState hListView, iCount-1,Val(Parse$(temp$,"::::",4))
      End If
   Wend
   Close #1
End Sub

Sub TreeViewCreateFromFile(sFileName$)
   Local temp$, i As Long, hTemp As Dword, iLevel As Long
   Local LevelHandle() As Long, D$, TreeData() As String, iUser&
   Dim LevelHandle(-1 To 100)
   D$ = "++" + "--" + ";;" + $CrLf

   'Clear anything already in the TreeView control
   Treeview Reset hDlg, %IDC_TreeView

   'put all data into array TreeData()
   Open sFileName$ For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   Dim TreeData(ParseCount(temp$, D$)-1)
   Parse temp$, TreeData(), D$

   'Handle the Root
   iLevel = Val(Parse$(TreeData(0), $CrLf, 1))  'level
   iUser = Val(Parse$(TreeData(0), $CrLf, 2))  'user value
   TreeData(0) = Parse$(TreeData(0),$CrLf,3)   'text content
   Treeview Insert Item hDlg, %IDC_TreeView, LevelHandle(iLevel-1), %TVI_Last, 0,0, TreeData(0) To hTemp
   LevelHandle(0) = hTemp

   'all other nodes - remember, all start with $crlf + D$
   For i = 1 To UBound(TreeData)
      iLevel = Val(Parse$(TreeData(i), $CrLf, 1))  'level
      iUser = Val(Parse$(TreeData(i), $CrLf, 2))  'user value
      TreeData(i) = Parse$(TreeData(i),$CrLf,3)   'text content
      Treeview Insert Item hDlg, %IDC_TreeView, LevelHandle(iLevel-1), %TVI_Last, 0,0, TreeData(i) To hTemp
      LevelHandle(iLevel) = hTemp
   Next i
End Sub

Sub ExportTree
   Local i, iLevel As Long, temp$, iReturn, hNode As Dword

   'Open file for output
   Open $TreeFile For Output As #1

   'get root node info from tree (top of tree)
   Treeview Get Root hDlg, %IDC_TreeView To hNode
   iLevel = 0
   Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
   Print #1, temp$

   'walk through rest of tree
   Do
      Treeview Get Child hDlg, %IDC_TreeView, hNode To iReturn                    'get child (1st choice)
      If iReturn Then Incr iLevel 'new level
      If iReturn = 0 Then Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn 'or sibling (2nd choice)
      If iReturn = 0 Then                                               'no child or sibling
         Do      'get sibling of first parent with sibling
            Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode            'parent
            Treeview Get Next hDlg, %IDC_TreeView, hNode To iReturn            'sibling child of parent
            Decr iLevel  'dropped one level
         Loop Until iReturn Or (hNode = 0)  'stop when find sibling of parent with sibling, or no more choices
      End If
      hNode = iReturn    'possible values: 0, zero (no parent/no sibling), <>0 (parent or sibling)
      'get info from tree
      If hNode Then
         Treeview Get Text hDlg, %IDC_TreeView, hNode To temp$
         If PlusTree Then
            Select Case iLevel
               Case 1    : Print #1, Repeat$(iLevel,"...") + temp$
               Case >1   : Print #1, Repeat$(iLevel-1,"...+") + "..." + temp$
            End Select
         Else
            Print #1, Repeat$(iLevel*4,".") + temp$
         End If
      End If
   Loop While hNode

   Close #1

   i = Shell("notepad.exe " + $TreeFile, 1)    'does not wait

End Sub

Sub SetHeaderIconsOnRight(ByVal iActiveColumn As Integer)
   Local i, iAlignRight As Integer, hdi As HD_ITEM
   For i = 0 To Header_GetItemCount(hHeader) - 1
      hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
      hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right
      If i = iActiveColumn Then hdi.iImage = SortDirection Else hdi.iImage = 3
      Header_SetItem(hHeader, i, hdi)
   Next
End Sub

Function LoadOneCursor(curName$) As Dword
   Local CurData$
   CurData$ = Resource$(RcData, curName$)
   Open "tempfiles\tempcursorfile.cur" For Binary As #1
   Put #1, ,Abs CurData$
   SetEof #1
   Close #1
   Function = LoadCursorFromFile ("tempfiles\tempcursorFile.cur")
   Kill "tempfiles\tempcursorFile.cur"
End Function

Sub ReArrangeListViewItems
   If StartItem = EndItem     Then Exit Sub
   If StartItem = EndItem - 1 Then Exit Sub

   Local i,iCount As Long, tempA$, tempB$, tempC$
   ListView Get Count hDlg, %IDC_ListView To iCount
   Incr StartItem : Incr EndItem

   ListView Get Text hDlg, %IDC_ListView, StartItem, 1 To tempA$
   ListView Get Text hDlg, %IDC_ListView, StartItem, 2 To tempB$
   ListView Get Text hDlg, %IDC_ListView, StartItem, 3 To tempC$

   ListView Insert Item hDlg, %IDC_Listview, EndItem, 0, tempA$
   ListView Set Text hDlg, %IDC_Listview, EndItem, 2, tempB$
   ListView Set Text hDlg, %IDC_Listview, EndItem, 3, tempC$

   If StartItem < EndItem Then
      ListView Delete Item hDlg, %IDC_ListView, StartItem
'      ListView Select hDlg, %IDC_ListView, EndItem-1
      ListView_SetItemState hListView, EndItem-2, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code
'      ListView_SetItemState hListView, EndItem-2, %LVIS_Focused, %LVIS_Focused '<--- synchronizing code
   Else
      ListView Delete Item hDlg, %IDC_ListView, StartItem+1
      ListView_SetItemState hListView, EndItem-1, %LVIS_Focused Or %LVIS_Selected, %LVIS_Focused Or %LVIS_Selected  '<--- synchronizing code

   End If
   Control Set Focus hDlg, %IDC_ListView
End Sub

Sub CheckAll(Flag As Long)
   Local i, iCount As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView_SetCheckState hListView, i-1, Flag
   Next i
End Sub

Sub DeleteChecked
   Local i, iCount, iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = iCount To 1 Step -1
      iResult = ListView_GetCheckState(hListView, i-1)
      If iResult Then ListView Delete Item hDlg, %IDC_ListView, i
   Next i
End Sub

Sub BuildOutputChecked(NPFlag As Long)
   Local x,y,i,iCount,pNumber As Long, temp$, tmp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   If NPFlag Then temp$ = NPCode + $CrLf
   For x = 1 To iCount
      y = ListView_GetCheckState(hListView, x-1)
      If y Then
         ListView Get Text hDlg, %IDC_ListView, x,3 To tmp$
         pNumber = Val(tmp$)
         ListView Get Text hDlg, %IDC_ListView, x,1 To tmp$
         For i = 0 To UBound(ProcedureData())
            If LCase$(ProcedureData(i).name) =  LCase$(tmp$) Then
               temp$ = temp$ + Procedures(pNumber)
               Exit For
            End If
         Next i
      End If
   Next x
   temp$ = Trim$(temp$, Any $CrLf + $Spc)
   SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
End Sub

Sub BuildOutputAll(NPFlag As Long)
   Local x,y,i,iCount,pNumber As Long, temp$, tmp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   If NPFlag Then temp$ = NPCode + $CrLf
   For x = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, x,3 To tmp$
      pNumber = Val(tmp$)
      ListView Get Text hDlg, %IDC_ListView, x,1 To tmp$
      For i = 0 To UBound(ProcedureData())
         If LCase$(ProcedureData(i).name) =  LCase$(tmp$) Then
            temp$ = temp$ + Procedures(pNumber)
            Exit For
         End If
      Next i
   Next x
   temp$ = Trim$(temp$, Any $CrLf + $Spc)
   SendMessage hSciB, %SCI_SetText, 0, StrPtr(temp$)
End Sub

Sub DisplayFindDialog()
   Local h As Long, w As Long
   Dialog Get Client hDlg To h,w
   Dialog New Pixels, hDlg, "Find & Replace      Target: " + IIf$(hSciF=hSciA,"Input","Output"), 100, 100, 360, 130, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hFind
   Dialog Set Icon hFind, "aainfo"

   Control Add Label, hFind, %IDF_FindThis, "Find This:", 5, 10, 60, 20
   Control Add Label, hFind, %IDF_ReplaceThis, "Replace With:", 5, 40, 70, 20

   Control Add TextBox, hFind, %IDF_FindText, SearchTerm, 80, 10, 185, 20
   Control Add TextBox, hFind, %IDF_ReplaceText, ReplaceTerm, 80, 40, 185, 20

   Control Add CheckBox, hFind, %IDF_MatchCase, "Match Case", 15, 70, 90, 20
   Control Add CheckBox, hFind, %IDF_MatchWord, "Match Whole Word", 15, 90, 120, 20
   Control Add Option, hFind, %IDF_UP, "Up", 165, 70, 90, 20
   Control Add Option, hFind, %IDF_Down, "Down", 165, 90, 90, 20
   Control Set Option hFind, %IDF_Down, %IDF_Up, %IDF_Down

   Control Add Button, hFind, %IDF_Find, "Find Next", 275, 10, 75, 20
   Control Add Button, hFind, %IDF_Replace, "Replace", 275, 40, 75, 20
   Control Add Button, hFind, %IDF_ReplaceAll, "Replace All", 275, 65, 75, 20
   Control Add Button, hFind, %IdCancel, "Close", 275, 100, 75, 20

   Dialog Show Modal hFind Call SearchProc()
End Sub

CallBack Function SearchProc() As Long
   Local iCheck&, x As Long, y As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         For x = %IDF_FindThis To %IDF_Down : Control Set Font hFind, x, hFontF : Next x
         Control Set Font hFind, %IdCancel, hFontF
         'get selected text and put into the FindText textbox
         SelLength = SendMessage(hSciF, %SCI_GetSelText, 0, 0)       'get length of selected text with Chr$(0)
         If SelLength>1 Then
            SelectedText = String$(SelLength," ")                      'set buffer to that length
            SendMessage hSciF, %SCI_GetSelText, 0, StrPtr(SelectedText) 'selected text + chr$(0)
            Control Set Text hFind, %IDF_FindText, SelectedText
         End If
         GetFindDialogData
         EnableFindButtons
      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
            Control Set Focus hDlg, sCID
         End If
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdCancel
               Dialog End hFind
            Case %IDF_Find       : FindNext(1)      'find, with warning
            Case %IDF_Replace    : ReplaceOnce(0)   'replace current selection
            Case %IDF_ReplaceAll : ReplaceAll       'replace all without warning
            Case %IDF_CLose      : Dialog End hFind
            Case %IDF_FindText, %IDF_ReplaceText
               If Cb.CtlMsg = %EN_Change Then GetFindDialogData : EnableFindButtons
         End Select
      Case %WM_Destroy
         Control Get Text hFind, %IDF_FindText To SearchTerm
         Control Get Text hFind, %IDF_ReplaceText To ReplaceTerm
         Control Set Focus hDlg, sCID               'focus
         Dialog End hFind
   End Select
End Function

Function FindNext(warning As Long) As Long
   Local iResult As Long
   GetFindDialogData
   FindStructure.Chrg.cpMin = SendMessage(hSciF,IIf(Direction, %SCI_GetCurrentPos, %SCI_GetAnchor),0,0) 'if up-curpos, if down-anchor
   FindStructure.Chrg.cpMax = Direction * SendMessage(hSciF,%SCI_GetLength,0,0) 'if up-length   if down-0
   FindStructure.lpstrText = StrPtr(xFindText)
   iResult = SendMessage (hSciF, %SCI_FindText, FindFlags, VarPtr(FindStructure))
   If iResult = -1 Then
      Function = 0   'no match
      If Warning = 1 Then
         If Direction = 1 Then MsgBox "Match not found between current position and end of document!", %MB_Ok Or %MB_IconExclamation, "Find Text"
         If Direction = 0 Then MsgBox "Match not found between current position and beginning of document!", %MB_Ok Or %MB_IconExclamation, "Find Text"
      End If
   Else
      Function = 1   'match found
      SendMessage hSciF, %SCI_SetSel, FindStructure.ChrgText.cpMin, FindStructure.ChrgText.cpMax
   End If
End Function

Function ReplaceOnce(Repeat As Long) As Long
   GetFindDialogData
   If SelLength = 1 Then
      Function = 0
      If Repeat = 0 Then MsgBox "No text selected for replacement!", %MB_Ok Or %MB_IconExclamation, "Find Text"  'notify user
      Exit Function                               'exit if no selection and a Replace is in work
   End If
   Function = 1
   SendMessage hSciF, %SCI_ReplaceSel, 0, StrPtr(xReplaceText)
   FindNext(0)
End Function

Sub ReplaceAll
   Local iResult As Long
   iResult = ReplaceOnce(1)
   Do While iResult
      iResult = ReplaceOnce(1)
   Loop
End Sub

Sub GetFindDialogData
   Control Get Text hFind, %IDF_FindText To xFindText          'find text
   If Trim$(xFindText)="" Then Exit Sub                        'no action is FindText is empty
   Control Get Text hFind, %IDF_ReplaceText To xReplaceText    'replace text
   xReplaceText = xReplaceText + Chr$(0)                        'replace text + chr$(0)
   xFindText = xFindText + Chr$(0)                              'find text + chr$(0)
   Control Get Check hFind, %IDF_MatchWord To MatchWord       'find whole words
   Control Get Check hFind, %IDF_MatchCase To MatchCase       'match case
   Control Get Check hFind, %IDF_Down To Direction            '1=down 0=up
   FindFlags = MatchCase * %SCFind_MatchCase + MatchWord * %SCFind_WholeWord  'search constraints
   SelLength = SendMessage(hSciF, %SCI_GetSelText, 0, 0)       'get length of selected text with Chr$(0)
   SelectedText = String$(SelLength," ")                      'set buffer to that length
   SendMessage hSciF, %SCI_GetSelText, 0, StrPtr(SelectedText) 'selected text + chr$(0)
   Anchor = SendMessage(hSciF, %SCI_GetAnchor, 0, 0)           'anchor
   CurPos = SendMessage(hSciF, %SCI_GetCurrentPos,0,0)         'current position
End Sub

Sub EnableFindButtons
   If Trim$(xFindText) = Chr$(0) Then
      Control Disable hFind, %IDF_Find : Control Disable hFind, %IDF_ReplaceAll
   Else
      Control Enable hFind, %IDF_Find  : Control Enable hFind, %IDF_Find
   End If
   If SelLength Then
      Control Enable hFind, %IDF_Replace
   Else
      Control Disable hFind, %IDF_Replace
   End If
End Sub

Sub LoadSkipList
   Local iCount As Long
   Open $SkipListFile For Binary As #1
   Get$ #1, Lof(1), SkipList
   Close #1
   Replace $CrLf With $Spc In SkipList
   SkipList = $Spc + LCase$(SkipList) + $Spc
End Sub

Sub SetOutputLabelText
   Select Case ControlType
      Case %cListView : Control Set Text hdlg, %IDC_LabelB, LabelList
      Case %cTreeView : Control Set Text hdlg, %IDC_LabelB, LabelTree
      Case %cScintilla : Control Set Text hdlg, %IDC_LabelB, LabelSci
   End Select
End Sub


Sub LoadIncludeContent(IName$)
   If IsFalse(IsFile(IName$)) Then
      If UseSpeech Then
         ReadText "File does not exist."
      Else
         sndPlaySound("MailBeep", %SND_Async)    'play sound once (in the background)
      End If
      Exit Sub
   End If
   Local temp$
   Open IName$ For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   SendMessage hSciA, %SCI_SetText, 0, StrPtr(temp$)
End Sub

Sub ReadText (sText As String)
   Local vRes, vTxt, vTime As Variant, oSp As Dispatch
   Let oSp = NewCom "SAPI.SpVoice"
   If IsFalse IsObject(oSp) Then Exit Sub
   vTxt = sText
   Object Call oSp.Speak(vTxt) To vRes
   vTime = -1 As Long
   Object Call oSp.WaitUntilDone(vTime) To vRes
End Sub

Sub  GetIncludesCode()
   Local i,j,iCount,iResult As Long, temp$, tmp$
   Dim tempArrayN() As String
   Dim tempArrayLC() As String
   IncludesCode = ""

   'make includes large enough to handle large number of include files
   iCount = UBound(Includes)  'starting number of include files in the INPUT code
   ReDim Preserve Includes(200)

   For i = 0 To UBound(Includes)
      If Len(Includes(i)) = 0 Then Exit For
      If IsFile(Includes(i)) = %False Then Iterate For
      'get text from Include file, add to IncludesCode string variable
      Open Includes(i) For Binary As #1 : Get$ #1, Lof(1), tmp$ : Close #1
      IncludesCode = IncludesCode + $CrLf + IIf$(UseIncludeSeparators,"'---" + Includes(i) + Repeat$(25,"-")+$CrLf,"") + tmp$

      'put text from include file into array
      ReDim tempArrayN(ParseCount(tmp$,$CrLf)-1)
      ReDim tempArrayLC(UBound(tempArrayN))
      Parse tmp$, tempArrayN(), $CrLf
      Parse LCase$(tmp$), tempArrayLC(), $CrLf

      'Scan Array For more include files
      If UseNestedIncludes Then
         For j = 0 To UBound(tempArrayLC)
            If Left$(tempArrayLC(j),8) = "#include" Then
               temp$ = Trim$(Parse$(tempArrayLC(j),Chr$(34),2)) 'get name of #Include file

   '            If IsFalse(IsFile(temp$)) Then Exit If  'must be valid file

               tmp$ = $Spc + PathName$(Namex,temp$) + $Spc 'cannot be a PB/Jose include
               If InStr(SkipList,tmp$)  Then Exit If

               Array Scan Includes(), Collate UCase, = temp$, To iResult  'no duplicates
               If iResult Then Exit If

               'add to Includes() array
               Incr iCount
               Includes(iCount) = Parse$(tempArrayN(j),Chr$(34),2)
            End If
         Next j
      End If
   Next i
   ReDim Preserve Includes(iCount)
End Sub

Sub LoadAPIList
   Open $APIListFile For Binary As #1 : Get$ #1, Lof(1), APISearchList : Close #1
   Replace $CrLf With $Spc In APISearchList
   APISearchList = $Spc + APISearchList + $Spc
End Sub

Sub ScanProcedureForAPI(iProc As Long)
  Local temp$, Intext$
  Local xWord,Buf,UCBuf As String
  Local i,j,StopPos,lnLen,Result,S As Long
  Local wFlag As Byte, Letter As Byte Ptr

  InText$ = Procedures(iProc)

  For J = 0 To ParseCount(InText$, $CrLf)-1
     Buf = Parse$(InText$,$CrLf,J)
     UCBuf = UCase$(Buf) + $Spc
     If Len(Trim$(UCBuf))=0 Then Iterate For
     lnLen = Len(UCBuf$)
     Letter = StrPtr(UCBuf) : wFlag = 0
     For I = 1 To Len(UCBuf)
        Select Case @Letter
           Case 97 To 122, 65 To 90, 192 To 214, 216 To 246, 248 To 255,35 To 38, 48 To 57, 63, 95 'word characters
              If wFlag = 0 Then wFlag = 1 : stopPos = I
           Case 34 'string quotes -> "
             stopPos = InStr(I + 1, UCBuf, Chr$(34)) 'Find match
             If stopPos Then
                StopPos = (StopPos - I + 1)
                I = I + StopPos
                Letter = Letter + StopPos
                wFlag = 0
             End If
           Case 39 'comment character -> '
              wFlag = 0
              Exit For
           Case Else  'word is ready
              If wFlag = 1 Then
                 xWord = Mid$(Buf, stopPos, I - stopPos)  'Get word
                 If xWord = "REM" Then wFlag = 0 : Exit For
                 wFlag = 0
                 '--- do something with the word here ---
                 If InStr(APISearchList, $Spc+LCase$(xWord)+$Spc) Then
                    APIUsedList = APIUsedList + $CrLf + xWord + ":::" + ProcedureData(iProc).name
                 End If
                 '---------------------------------------
              End If
        End Select
        Incr Letter
     Next I
  Next J
  APIUsedList = Trim$(APIUsedList, Any $CrLf + $Spc)
End Sub

Sub BuildAPITree
   Local i As Long, hRoot, hAPI,hTemp As Dword, aName, pName, oldaName, oldpName As String
   Treeview Reset hDlg, %IDC_TreeView
   Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 0, 0, "API Called By Tree  (" + LCase$(PathName$(Namex,FileName)) + ")" To hRoot
   'build APIList and put into array
   APIUsedList = ""
   For i = 0 To UBound(Procedures) : ScanProcedureForAPI(i) : Next i
   ReDim tempAPIArray(ParseCount(APIUsedList,$CrLf)-1)
   Parse APIUsedList, tempAPIArray(), $CrLf
   Array Sort tempAPIArray(), Collate UCase
   'build tree
   For i = 0 To UBound(tempAPIArray)
      If (i>0) And tempAPIArray(i) = tempAPIArray(i-1) Then Iterate For
      If Len(tempAPIArray(i))=0 Then Iterate For
      aName = Parse$(tempAPIArray(i),":::",1)
      pName = Parse$(tempAPIArray(i),":::",2)
      If aName <> oldaName Then
         Treeview Insert Item hDlg, %IDC_TreeView, hRoot, %TVI_Last, 0, 0, aName To hAPI
      End If
      Treeview Insert Item hDlg, %IDC_TreeView, hAPI, %TVI_Last, 0, 0, pName To hTemp
      oldaName = aName : oldpName = pName
   Next i
   Treeview Set Expanded hDlg, %IDC_TreeView, hRoot, %True
   TreeNodeExpand(hRoot, %True)
End Sub

Sub GoToProcedure_ListView
   Local pName, pType As String, iPos As Long
   'get procedure name
   ListView Get Select hDlg, %IDC_ListView To iPos
   ListView Get Text hDlg, %IDC_ListView, iPos, 1 To pName
   ListView Get Text hDlg, %IDC_ListView, iPos, 2 To pType

   'if Include, load the include file content
   If InStr(pType,"Include") Then
      LoadIncludeContent pName
      Exit Sub
   End If

   'was not an include file, so GoTo selected procedure
   pName = IIf$(LCase$(pType)="callback","Callback Function", pType) + $Spc + pName + $Nul

   'set Sci search structure
   FindStructure.Chrg.cpMin = 0
   FindStructure.Chrg.cpMax = SendMessage(hSciA,%SCI_GetLength,0,0)
   FindStructure.lpstrText = StrPtr(pName)

   'find search term
   iPos = SendMessage (hSciA, %SCI_FindText, 0, VarPtr(FindStructure))
   If iPos = -1 Then
      Beep
   Else
      SendMessage hSciA, %SCI_SetSel, FindStructure.ChrgText.cpMin, FindStructure.ChrgText.cpMax
      Control Set Focus hDlg, %IDC_ScintillaA
      iPos = SendMessage(hSciA, %SCI_LineFromPosition, FindStructure.ChrgText.cpMin,0)
      SendMessage hSciA, %SCI_SetFirstVisibleLine, iPos, 0
   End If
End Sub

Sub GoToProcedure_TreeView
   Local pName, sName As String, FoundFlag, i,iPos As Long, hItem,hTemp As Dword
   'get procedure name
   Treeview Get Select hDlg, %IDC_TreeView To hItem
   'not works on parent nodes
   Treeview Get Child hDlg, %IDC_TreeView, hItem To hTemp
   If hTemp Then Exit Sub

   'set search info
   Treeview Get Text hDlg, %IDC_TreeView, hItem To pName
   For i = 1 To 3
      If i = 1 Then sName = "Function " + pName + $Nul
      If i = 2 Then sName = "Sub " + pName + $Nul
      If i = 3 Then sName = "Class " + pName + $Nul

      FindStructure.Chrg.cpMin = 0
      FindStructure.Chrg.cpMax = SendMessage(hSciA,%SCI_GetLength,0,0)
      FindStructure.lpstrText = StrPtr(sName)

      'find search term
      iPos = SendMessage (hSciA, %SCI_FindText, 0, VarPtr(FindStructure))
      If iPos > -1 Then FoundFlag = 1 : Exit For
   Next i

   If FoundFlag Then
      SendMessage hSciA, %SCI_SetSel, FindStructure.ChrgText.cpMin, FindStructure.ChrgText.cpMax
      Control Set Focus hDlg, %IDC_ScintillaA
      iPos = SendMessage(hSciA, %SCI_LineFromPosition, FindStructure.ChrgText.cpMin,0)
      SendMessage hSciA, %SCI_SetFirstVisibleLine, iPos, 0
   Else
      Beep
   End If
End Sub

Function TrimComments(Txt As String) As String
   Local i, qFlag As Long, c As String
   For i = 1 To Len(Txt)
      c = Mid$(Txt,i,1)
      If c = $Dq And qFlag = 1 Then
         qFlag = 0
      ElseIf c = $Dq Then
         qFlag = 1
      ElseIf c = "'" And qFlag = 0 Then
         Function = RTrim$(Left$(Txt,i-1))   'found single-quote character not embedded in double-quotes
         Exit Function
      End If
   Next i
   Function = Txt
End Function

Sub JustifyCode
   Local x,y,xline,yline,iTopLine,iCount,i,StartPos,StartLine,iSelection As Long, temp$, D() As String
   iTopLine = SendMessage(hSciB, %Sci_GetFirstVisibleLine, 0, 0)

   'put Sci Text into array
   temp$ = GetSciText(hSciB)
   iCount = ParseCount(temp$, $CrLf)
   Dim D(iCount -1 )
   Parse temp$, D(), $CrLf

   'get selection boundary
   StartPos = SendMessage(hSciB,%SCI_GetSelectionStart,0,0)
   StartLine = SendMessage(hSciB, %SCI_LineFromPosition,StartPos,0)
   x = StartPos
   y = SendMessage(hSciB,%SCI_GetSelectionEnd,0,0)
   If x = y Then x = 0 : y = SendMessage(hSciB, %SCI_GetLength, 0, 0) : iSelection = 0 Else iSelection = 1
   xLine = SendMessage(hSciB, %SCI_LineFromPosition,x,0)
   yLine = SendMessage(hSciB, %SCI_LineFromPosition,y,0)

   'left justify selected lines
   For i = xline To yline
      D(i) = LTrim$(D(i))
   Next i
   temp$ = Join$(d(), $CrLf)

   'put modified text back into hSciB
   SendMessage(hSciB,%SCI_SetText,0,StrPtr(temp$))

   'Select the modified lines
   If iSelection Then
      x = SendMessage(hSciB, %SCI_PositionFromLine, xLine,0)
      y = SendMessage(hSciB, %SCI_GetLineEndPosition, yLine,0)
      SendMessage hSciB, %SCI_SetSel, x,y
   Else
      StartPos = SendMessage(hSciB, %SCI_PositionFromLine,StartLine,0)
      SendMessage hSciB, %SCI_SetEmptySelection, StartPos, 0
   End If

   'scroll to the original polsistion
   iTopLine = SendMessage(hSciB, %Sci_SetFirstVisibleLine, iTopLine, 0)
End Sub

Sub FormatCode
   Local x,y,xline,yline,iTopLine,iCount,i,StartPos,StartLine,iSelection As Long
   Local PreText$, PostText$, temp$,tmp$, D() As String
   iTopLine = SendMessage(hSciB, %Sci_GetFirstVisibleLine, 0, 0)

   'put Sci Text into array
   temp$ = GetSciText(hSciB)
   iCount = ParseCount(temp$, $CrLf)
   Dim D(iCount -1 )
   Parse temp$, D(), $CrLf

   'get selection boundary
   StartPos = SendMessage(hSciB,%SCI_GetSelectionStart,0,0)
   StartLine = SendMessage(hSciB, %SCI_LineFromPosition,StartPos,0)
   x = StartPos
   y = SendMessage(hSciB,%SCI_GetSelectionEnd,0,0)
   If x = y Then x = 0 : y = SendMessage(hSciB, %SCI_GetLength, 0, 0) : iSelection = 0 Else iSelection = 1
   xLine = SendMessage(hSciB, %SCI_LineFromPosition,x,0)
   yLine = SendMessage(hSciB, %SCI_LineFromPosition,y,0)

   'format selected lines
   For i = 0 To UBound(D)
      Select Case i
         Case < xLine  : PreText$ += $CrLf + D(i)
         Case > yLine  : PostText$ += $CrLf + D(i)
         Case Else : tmp$ += $CrLf + D(i)
      End Select
   Next i

   'format the code
   temp$ = CodeIndent(tmp$)  'N is indentation, B Is Max blank Lines, P  is exact number of blank lines required before a construct

   'put modified text back into hSciB
   temp$ = PreText$ + $CrLf + temp$ + $CrLf
   yLine = ParseCount(temp$,$CrLf)
   temp$ = temp$ + PostText$
   temp$ = Trim$(temp$, Any $CrLf + $Spc)
   SendMessage(hSciB,%SCI_SetText,0,StrPtr(temp$))

   'Select the modified lines
   If iSelection Then
      x = SendMessage(hSciB, %SCI_PositionFromLine, xLine,0)
      y = SendMessage(hSciB, %SCI_GetLineEndPosition, yLine,0)
      SendMessage hSciB, %SCI_SetSel, x,y
   Else
      StartPos = SendMessage(hSciB, %SCI_PositionFromLine,StartLine,0)
      SendMessage hSciB, %SCI_SetEmptySelection, StartPos, 0
   End If

   'scroll to the original polsistion
   iTopLine = SendMessage(hSciB, %Sci_SetFirstVisibleLine, iTopLine, 0)
End Sub

Function CodeIndent(temp$) As String
   Local lctemp$,iPos,bCount,i,j,Flag,iCount,iMax,cFlag, sFlag, dFlag, fFlag, bFlag,iLevel As Long, lcD(), tempD(), D() As String

   If Len(temp$) = 0 Then Exit Function
   Replace $Tab With Space$(IndentSize) In temp$
   lctemp$ = LCase$(temp$)

   i = ParseCount(temp$, $CrLf)
   ReDim D(i-1), lcD(i-1), tempD(4*i)
   Parse temp$,     D(), $CrLf
   Parse lctemp$, lcD(), $CrLf

   'test start of each line to know how much to indent
   iPos = -1
   Dialog Set Text hDlg, "gbCodeIndent   " + $Ver + "   ... formatting ... please wait!"
   For i = 0 To UBound(D)
'      If (i Mod 500) = 0 Then
'         Dialog Set Text hDlg, "gbCodeIndent   " + $Ver + "       Line: " + Str$(i) + "   Complete: " + Format$(100*i/UBound(D),"##") + "%"
'      End If

      D(i) = Trim$(D(i), Any $Spc + $Tab)
      If Len(D(i)) = 0 And ManageBlankLines Then Incr bCount : Iterate For
      If Len(D(i)) = 0 Then GoTo Finish
      temp$ = Trim$(TrimComments(lcD(i)))
      If cFlag Then IndentD1 : GoTo Finish     'previous line ended in _ so use this line as is, with indentation to iLevel, iLevel remains unchanged
      If Right$(temp$,1)  = ":" And Verify(temp$,Chr$(97 To 122, 48 To 58, 95)) = 0 Then  GoTo Finish    'labels  no indentation, lower case, numbers, underline

'zero indentation constructs ==============================================================================================================================
      'single line, multi-statement constructs (No children)
      If Left$(temp$,6)  = "macro " And InStr(temp$,"=")                     Then IG  ' Macro myMacro = x=2
      If Left$(temp$,5)  = "type " And Right$(temp$,8) = "end type"          Then IG  ' Type x : ... : End Type
      If Left$(temp$,6)  = "union " And Right$(temp$,9) = "end union"        Then IG  ' Union x : ... : End Union
      If Left$(temp$,4)  = "sub " And Right$(temp$,7) = "end sub"            Then IG  ' Sub x : ... : End Sub
      If Left$(temp$,9)  = "function " And Right$(temp$,12) = "end function" Then IG  ' Function x : ... : End Function
      If Left$(temp$,9)  = "callback " And Right$(temp$,12) = "end function" Then IG  ' Callback Function x : ... : End Function
      If Left$(temp$,7)  = "thread " And Right$(temp$,12) = "end function"   Then IG  ' Thread Function x : ... : End Function

      If Left$(temp$,9)  = "fastproc " And Right$(temp$,12) = "end fastproc" Then IG  ' FastProc x : ... : End FastProc
      If Left$(temp$,8)  = "asmdata " And Right$(temp$,11) = "end asmdata"   Then IG  ' ASMData x : ... : End ASMData

      'multi-line constructs (Children)
      If Left$(temp$,6)  = "macro "                                          Then IIFG
      If Left$(temp$,9)  = "end macro"                                       Then DIG
      If Left$(temp$,5)  = "type " And Left$(temp$,8) <> "type set"          Then IIFG
      If Left$(temp$,8)  = "end type"                                        Then DIG
      If Left$(temp$,6)  = "union "                                          Then IIFG
      If Left$(temp$,9)  = "end union"                                       Then DIG
      If Left$(temp$,4)  = "sub "                                            Then IIFG
      If Left$(temp$,7)  = "end sub"                                         Then DIG
      If Left$(temp$,9)  = "function " And Left$(temp$,10) <> "function ="   Then IIFG
      If Left$(temp$,9)  = "callback "                                       Then IIFG
      If Left$(temp$,16) = "thread function "                                Then IIFG
      If Left$(temp$,12) = "end function"                                    Then DIG

      If Left$(temp$,5)  = "enum "                                          Then IIFG
      If Left$(temp$,8)  = "end enum"                                       Then DIG
      If Left$(temp$,7)  = "prefix "                                        Then IIFG
      If Left$(temp$,10) = "end prefix"                                     Then DIG
      If Left$(temp$,8)  = "asmdata "                                       Then IIFG
      If Left$(temp$,11) = "end asmdata"                                    Then DIG
      If Left$(temp$,9)  = "fastproc "                                      Then IIFG
      If Left$(temp$,12) = "end fastproc"                                   Then DIG

'n-level indentation constructs ===========================================================================================================================
      'single line, multi-statement constructs (No children)
      If Left$(temp$,3)  = "if "  And InStr(-1,temp$,"then ") And Len(Mid$(temp$,InStr(-1,temp$,"then ")+5)) > 0             Then IG  ' If x then y=2
      If Left$(temp$,3)  = "if "  And InStr(-1,temp$,"else ") And Len(Mid$(temp$,InStr(-1,temp$,"else ")+5)) > 0             Then IG  ' If x then y=2 else z=4

      If Left$(temp$,4)  = "for " And InStr(-1,temp$,"next ") And Len(Mid$(temp$,InStr(-1,temp$,"next ")+5)) > 0             Then IG  ' For x=2 To 5 : next i

      If Left$(temp$,3)  = "do " And Right$(temp$,4) = "loop"                                                                Then IG  ' Do Until/While : ... : Loop
      If Left$(temp$,3)  = "do:" And Right$(temp$,4) = "loop"                                                                Then IG  ' Do: ... : Loop

      If Left$(temp$,3)  = "do " And InStr(-1,temp$,"loop while ") And Len(Mid$(temp$,InStr(-1,temp$,"loop while ")+11)) > 0 Then IG  ' Do .. : .. : Loop While x=2
      If Left$(temp$,3)  = "do " And InStr(-1,temp$,"loop until ") And Len(Mid$(temp$,InStr(-1,temp$,"loop until ")+11)) > 0 Then IG  ' Do .. : .. : Loop Until x=2
      If Left$(temp$,3)  = "do:" And InStr(-1,temp$,"loop while ") And Len(Mid$(temp$,InStr(-1,temp$,"loop while ")+11)) > 0 Then IG  ' Do: .. : Loop While x=2
      If Left$(temp$,3)  = "do:" And InStr(-1,temp$,"loop until ") And Len(Mid$(temp$,InStr(-1,temp$,"loop until ")+11)) > 0 Then IG  ' Do: .. : Loop Until x=2

      If Left$(temp$,6)  = "while " And Right$(temp$,4) = "wend"                                                             Then IG  ' While x=2 : y=3 : Wend
      If Left$(temp$,4)  = "try " And Right$(temp$,7) = "end try"                                                            Then IG  ' Try : ... : ... : End Try
      If Left$(temp$,4)  = "try:" And Right$(temp$,7) = "end try"                                                            Then IG  ' Try: ... : ... : End Try

      'multi-line constructs (Children)
      If Left$(temp$,3)  = "if "                 Then IIG
      If Left$(temp$,7)  = "elseif "             Then DIIG
      If Left$(temp$,5)  = "else "               Then DIIG
      If Left$(temp$,5)  = "else:"               Then DIIG
      If temp$ = "else"                          Then DIIG
      If Left$(temp$,6)  = "end if"              Then DIG

      If Left$(temp$,4)  = "#if "                Then dFlag = 1 : IIG
      If Left$(temp$,8)  = "#elseif "            Then DIIG
      If temp$ = "#else"                         Then DIIG
      If temp$ = "#endif"                        Then dFlag = 0 : DIG

      If Left$(temp$,4)  = "for "                Then IIG    ' For i = 1 to 10    (space after For)
      If Left$(temp$,5)  = "next "               Then DIG    ' Next i
      If Left$(temp$,5)  = "next:"               Then DIG    ' Next:
      If temp$ = "next"                          Then DIG    ' Next    (nothing behind it)

      If Left$(temp$,3)  = "do "                 Then IIG
      If Left$(temp$,3)  = "do:"                 Then IIG
      If temp$ = "do"                            Then IIG
      If Left$(temp$,5)  = "loop "               Then DIG
      If Left$(temp$,5)  = "loop:"               Then DIG
      If temp$ = "loop"                          Then DIG
      If Right$(temp$,5) = " loop" And Right$(temp$,9) <> "exit loop"  Then DIG
      If Right$(temp$,5) = ":loop"               Then DIG

      If Left$(temp$,6)  = "while "              Then IIG
      If Left$(temp$,5)  = "wend "               Then DIG
      If Left$(temp$,5)  = "wend:"               Then DIG
      If temp$ = "wend"                          Then DIG

      If Left$(temp$,7)  = "select "             Then sFlag = 1 : IIG
      If sFlag Then
          If Left$(temp$,5)  = "case "               Then sFlag = 0 : IIG
          If Left$(temp$,5)  = "case:"               Then sFlag = 0 : IIG
          If temp$ = "case"                          Then sFlag = 0 : IIG
          If Left$(temp$,10)  = "case else "         Then sFlag = 0 : IIG
          If Left$(temp$,10)  = "case else:"         Then sFlag = 0 : IIG
      Else
          If Left$(temp$,5)  = "case "               Then sFlag = 0 : DIIG
          If Left$(temp$,5)  = "case:"               Then sFlag = 0 : DIIG
          If temp$ = "case"                          Then sFlag = 0 : DIIG
          If Left$(temp$,10)  = "case else "         Then sFlag = 0 : DIIG
          If Left$(temp$,10)  = "case else:"         Then sFlag = 0 : DIIG
          If temp$ = "case else"                     Then sFlag = 0 : DIIG
      End If
      If Left$(temp$,10) = "end select"          Then sFlag = 0 : Decr iLevel : DIG

      If Left$(temp$,4) = "try "                 Then IIG
      If Left$(temp$,4) = "try:"                 Then IIG
      If temp$ = "try"                           Then IIG

      If Left$(temp$,6) = "catch "               Then DIIG
      If Left$(temp$,6) = "catch:"               Then DIIG
      If temp$ = "catch"                         Then DIIG

      If Left$(temp$,8) = "finally " And Right$(temp$,8) = "end try "   Then DIG
      If Left$(temp$,8) = "finally " And Right$(temp$,8) = "end try:"   Then DIG
      If Left$(temp$,8) = "finally " And Right$(temp$,7) = "end try"    Then DIG

      If Left$(temp$,8) = "finally:" And Right$(temp$,8) = "end try "   Then DIG
      If Left$(temp$,8) = "finally:" And Right$(temp$,8) = "end try:"   Then DIG
      If Left$(temp$,8) = "finally:" And Right$(temp$,7) = "end try"    Then DIG

      If Left$(temp$,8) = "finally "             Then DIIG
      If Left$(temp$,8) = "finally:"             Then DIIG
      If temp$ = "finally"                       Then DIIG

      If Left$(temp$,8) = "end try "             Then DIG    ' End Try :  (statement following on same line)
      If Left$(temp$,8) = "end try:"             Then DIG    ' End Try:   (statement following on same line)
      If temp$ = "end try"                       Then DIG    ' End Try    (alone)

'objects ==============================================================================================================================

      If Left$(temp$,13) = "class method "         Then IIG
      If Left$(temp$,16) = "override method "      Then IIG

      If Left$(temp$,6)  = "class "     And Left$(temp$,10) <> "function ="      Then IIFG
      If Left$(temp$,9)  = "end class"                                           Then DIG

      If Left$(temp$,10) = "interface " And Right$(temp$,13) = "end interface"   Then IG  ' Interface : ... : End Interface
      If Left$(temp$,7)  = "method "    And Right$(temp$,10) = "end method"      Then IG  ' Method    : ... : End Method
      If Left$(temp$,9)  = "property "  And Right$(temp$,12) = "end property"    Then IG  ' Property  : ... : End Property

      If Left$(temp$,10) = "interface "            Then IIG
      If Left$(temp$,13) = "end interface"         Then DIG

      If Left$(temp$,9)  = "property " And Left$(temp$,10) <> "property ="   Then IIG
      If Left$(temp$,12) = "end property"          Then DIG

      If Left$(temp$,7)  = "method "               Then IIG
      If Left$(temp$,10) = "end method"            Then DIG

'all other lines =====================================================================================================================
      D(i) = Space$(iLevel*IndentSize) + D(i)

Finish:
      If Right$(temp$,1) = "_" Then cFlag = 1 Else cFlag = 0
      If fFlag And ManageBlankLines Then
         For j = 1 To fixedB : Incr iPos : Next j
      Else
         For j = 1 To Min(bCount,maxB) : Incr iPos : Next j
      End If
      Incr iPos : tempD(iPos) = D(i) : bCount = 0 : fFlag = 0
   Next i
   ReDim Preserve tempD(iPos)
   Function = Join$(tempD(), $CrLf)
End Function
